
CREATE OR REPLACE FUNCTION asatdate(asat date)
  RETURNS sp_status AS
$BODY$
declare     unmatched_row       unmatched%rowtype;
            pcost_row           record;
            Psumunmatched      integer;
            Psumpcost           integer;
			firstline			integer;
             cur_asset_reg char(1);
            cur_pdesc   char(4);
            cur_reg char(6);
            cur_qty integer;
            cur_dat date;
            cur_qty_unmatched integer;
            cur_qty_matched integer;
            cur_qty_sold integer;
            cur_sales_period date;
            cur_nominal_period date;
            cur_unit_cost decimal(16,2);
            cur_unit_depn decimal(16,2);
            cur_supp char(6);
            cur_invoice_ref char(10);
            cur_location integer;
            cur_pcost_ser integer;
            cur_qty_invoiced integer;			
            err			sp_status;

                                
begin 

         
drop table if exists temp_unmatched;
drop table if exists temp_pcost;

create temp table temp_unmatched
  (
      ser serial not null ,
      asset_reg char(1),
      pdesc char(4),
      reg char(6),
      qty integer,
      dat date,
      cost_per_unit decimal(9,2),
      supplier char(6),
      qty_left integer,
      qty_sold integer,
      location smallint
        );

create temp table temp_pcost
     (
      ser integer,
      asset_reg char(1),
      pdesc char(4),
      reg char(6),
      unit_cost decimal(16,2),
      unit_depn decimal(16,2),
      qty integer,
      dat date,
      supplier char(6),
      invoice_ref char(10),
      source_type char(1),
      original_qty integer,
      qty_invoiced integer
       );



	cur_qty_matched :=0;
	firstline := 1;
	
	for pcost_row in  
	    select h.pcost as pcost, h.ser, h.asset_reg, h.pdesc, h.reg,
                   h.typ, h.sales_period,
                   h.dat, h.unit_cost, h.unit_depn, h.qty,
                   h.supp, h.invoice_ref, h.location, pd.typ as pdtyp
          
        from phistory h, pdesc pd
	    where h.sales_period <= asat
	    and h.pdesc = pd.cod
	    and h.pcost is not null
        order by 1,2	
	loop
	
	    if firstline = 1 then
	       cur_pcost_ser     := pcost_row.pcost;
           cur_asset_reg     := pcost_row.asset_reg;
           cur_pdesc         := pcost_row.pdesc;
           cur_reg           := pcost_row.reg;
           cur_qty           := 0;
           cur_qty_unmatched := 0;
           cur_qty_matched   := 0;
           cur_qty_sold      := 0;
           cur_unit_cost     := 0;
           cur_unit_depn     := 0;
           cur_invoice_ref   := '';
           cur_supp          := '';
           cur_location      := 1;
           cur_qty_invoiced  := 0;
           firstline         := 0;
        end if;
	
       if cur_pcost_ser <> pcost_row.pcost then

           if cur_qty_matched > 0 then
              
	           execute 'insert into temp_pcost values (' || coalesce(quote_literal(cur_pcost_ser),'NULL') || ','
                                            || coalesce(quote_literal(cur_asset_reg),'NULL') || ','
                                            || coalesce(quote_literal(cur_pdesc),'NULL')     ||','
                                            || coalesce(quote_literal(cur_reg),'NULL')        ||','
                                            || coalesce(quote_literal(cur_unit_cost),'NULL') ||','
                                            || coalesce(quote_literal(cur_unit_depn),'NULL') ||','
                                            || coalesce(quote_literal(cur_qty_matched),'NULL')       ||','
                                            || coalesce(quote_literal(cur_dat),'NULL')       ||','
                                            || coalesce(quote_literal(cur_supp),'NULL')    ||','
                                            || coalesce(quote_literal(cur_invoice_ref),'NULL') ||','
                                            || coalesce(quote_literal(''),'NULL') ||
											|| coalesce(quote_literal(cur_qty_matched),'NULL') ||
											|| coalesce(quote_literal(cur_qty_invoiced),'NULL') ||
                                            ');';					 
           end if;

	       cur_pcost_ser     := pcost_row.pcost;
           cur_asset_reg     := pcost_row.asset_reg;
           cur_pdesc         := pcost_row.pdesc;
           cur_reg           := pcost_row.reg;
           cur_qty           := 0;
           cur_qty_unmatched := 0;
           cur_qty_matched   := 0;
           cur_qty_sold      := 0;
           cur_unit_cost     := 0;
           cur_unit_depn     := 0;
           cur_invoice_ref   := '';
           cur_supp          := '';
           cur_location      := 1;
           cur_qty_invoiced  := 0;
           

        end if;	
	
       if pcost_row.typ = 1 then
             cur_dat           := pcost_row.dat;
             cur_invoice_ref   := pcost_row.invoice_ref;
             cur_supp          := pcost_row.supp;
             cur_location      := pcost_row.location;
             cur_unit_cost     := pcost_row.unit_cost;
             cur_unit_depn     := pcost_row.unit_depn;
             cur_qty_matched   := cur_qty_matched   + pcost_row.qty;
        end if;
		
        if pcost_row.typ = 2 then
            cur_invoice_ref   := pcost_row.invoice_ref;
            cur_supp          := pcost_row.supp;
            cur_unit_cost     := pcost_row.unit_cost;
            cur_qty_invoiced  := cur_qty_invoiced  + pcost_row.qty;
        end if;
		
        if pcost_row.typ = 3 then
            if pcost_row.pdtyp = "M" then
                cur_qty_matched   := cur_qty_matched   - pcost_row.qty;
            else
                cur_qty_matched := 0;
            end if;
        end if;
		
        if pcost_row.typ = 4 then
            cur_unit_depn     := cur_unit_depn     + pcost_row.unit_depn;
        end if;	
		
        if pcost_row.typ = 5 then
            if pcost_row.qty > 0 then
                cur_unit_cost := pcost_row.unit_cost;
            end if;
        end if;

        if pcost_row.typ = 6 then
            cur_qty           := cur_qty           - hst_qty;
        end if;
		
		
        if pcost_row.typ = 7 then
            cur_dat           := pcost_row.dat;
            cur_invoice_ref   := pcost_row.invoice_ref;
            cur_supp          := pcost_row.supp;
            cur_location      := pcost_row.location;
            cur_unit_cost     := pcost_row.unit_cost;
            cur_unit_depn     := pcost_row.unit_depn;
            cur_qty_matched   := cur_qty_matched   + pcost_row.qty;
        end if;
		
        if pcost_row.typ = 8 then
            if pcost_row.pdtyp = "M" then
                cur_qty_matched   := cur_qty_matched   - pcost_row.qty;
            else
                cur_qty_matched   = 0;
            end if;
        end if;
        
        if pcost_row.typ = 9 then
            cur_unit_depn     := cur_unit_depn     + pcost_row.unit_depn;
        end if;

	if pcost_row.typ = 10 then
            cur_qty_invoiced  := cur_qty_invoiced  - pcost_row.qty;
        end if;
   
   
      

	
	end loop;
	
	
	if cur_qty_matched <> 0 then
               execute 'insert into temp_pcost values (' || coalesce(quote_literal(cur_pcost_ser),'NULL') || ','
                                            || coalesce(quote_literal(cur_asset_reg),'NULL') || ','
                                            || coalesce(quote_literal(cur_pdesc),'NULL')     ||','
                                            || coalesce(quote_literal(cur_reg),'NULL')        ||','
                                            || coalesce(quote_literal(cur_unit_cost),'NULL') ||','
                                            || coalesce(quote_literal(cur_unit_depn),'NULL') ||','
                                            || coalesce(quote_literal(cur_qty_matched),'NULL')       ||','
                                            || coalesce(quote_literal(cur_dat),'NULL')       ||','
                                            || coalesce(quote_literal(cur_supp),'NULL')    ||','
                                            || coalesce(quote_literal(cur_invoice_ref),'NULL') ||','
                                            || coalesce(quote_literal(''),'NULL') ||
											|| coalesce(quote_literal(cur_qty_matched),'NULL') ||
											|| coalesce(quote_literal(cur_qty_invoiced),'NULL') ||
                                            ');';					 
    end if;

	execute 'create unique index t_ix312_1 on temp_pcost (ser)';
    execute 'create index t_multidx on temp_pcost (pdesc);';
    execute 'create index pcix2 on temp_pcost (asset_reg,pdesc,reg)';
	
	
	
	
    
    err.ret_stat := 0;
    err.ret_string := 'SUCCESS';

    return err;
      
              
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION asatdate(date) OWNER TO postgres;
