------------------------------------------------
-- Bank Reconciliation changes Required for v4_6
------------------------------------------------

create table banknlxref
  (
    nsuk serial not null ,
    nltrans_id integer,
    bank_rec_id integer,
    cleared integer,
    primary key (nsuk)
  );



create table bank_rec
  (
    nsuk serial not null ,
    statement_date date,
    opening_balance decimal(16,2),
    closing_balance decimal(16,2),
    operator_id smallint,
    date_processed date,
    primary key (nsuk)
  );

alter table bank_rec add constraint fk_oper_id foreign key (operator_id) references operator ;

alter table banknlxref add constraint fk_bankrecid foreign key (bank_rec_id) references bank_rec ;
create index banknlxref_nltrans_id on banknlxref(nltrans_id);