--
-- PostgreSQL database dump
--

-- Started on 2010-08-30 15:33:03

SET client_encoding = 'LATIN9';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

--
-- TOC entry 296 (class 2612 OID 128745)
-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: -; Owner: postgres
--

CREATE PROCEDURAL LANGUAGE plpgsql;


ALTER PROCEDURAL LANGUAGE plpgsql OWNER TO postgres;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 1301 (class 1259 OID 128746)
-- Dependencies: 1664 1665 5
-- Name: alert; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE alert (
    nsuk integer NOT NULL,
    created_by_id integer,
    name character varying(64) NOT NULL,
    active_from timestamp without time zone,
    active_to timestamp without time zone,
    active character(1) DEFAULT 'Y'::bpchar NOT NULL,
    deleted character(1) DEFAULT 'N'::bpchar NOT NULL,
    created timestamp without time zone NOT NULL,
    updated timestamp without time zone NOT NULL
);


ALTER TABLE public.alert OWNER TO postgres;

--
-- TOC entry 1302 (class 1259 OID 128750)
-- Dependencies: 5
-- Name: alert_bool; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE alert_bool (
    nsuk integer NOT NULL,
    bool_operator character varying(20) NOT NULL
);


ALTER TABLE public.alert_bool OWNER TO postgres;

--
-- TOC entry 1303 (class 1259 OID 128752)
-- Dependencies: 5 1302
-- Name: alert_bool_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE alert_bool_nsuk_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.alert_bool_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1785 (class 0 OID 0)
-- Dependencies: 1303
-- Name: alert_bool_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE alert_bool_nsuk_seq OWNED BY alert_bool.nsuk;


--
-- TOC entry 1304 (class 1259 OID 128754)
-- Dependencies: 1668 1669 5
-- Name: alert_clause; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE alert_clause (
    nsuk integer NOT NULL,
    alert_id integer NOT NULL,
    clause_order integer NOT NULL,
    alert_bool_id integer NOT NULL,
    type_id integer,
    operator_id integer,
    lower character varying(64) NOT NULL,
    upper character varying(64),
    active character(1) DEFAULT 'Y'::bpchar NOT NULL,
    deleted character(1) DEFAULT 'N'::bpchar NOT NULL,
    created timestamp without time zone NOT NULL,
    updated timestamp without time zone NOT NULL
);


ALTER TABLE public.alert_clause OWNER TO postgres;

--
-- TOC entry 1305 (class 1259 OID 128758)
-- Dependencies: 5 1304
-- Name: alert_clause_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE alert_clause_nsuk_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.alert_clause_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1786 (class 0 OID 0)
-- Dependencies: 1305
-- Name: alert_clause_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE alert_clause_nsuk_seq OWNED BY alert_clause.nsuk;


--
-- TOC entry 1306 (class 1259 OID 128760)
-- Dependencies: 5
-- Name: alert_message; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE alert_message (
    nsuk integer NOT NULL,
    alert_raised_id integer,
    recipient_id integer,
    message character varying(255) NOT NULL,
    delivered timestamp without time zone
);


ALTER TABLE public.alert_message OWNER TO postgres;

--
-- TOC entry 1307 (class 1259 OID 128762)
-- Dependencies: 1306 5
-- Name: alert_message_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE alert_message_nsuk_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.alert_message_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1787 (class 0 OID 0)
-- Dependencies: 1307
-- Name: alert_message_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE alert_message_nsuk_seq OWNED BY alert_message.nsuk;


--
-- TOC entry 1308 (class 1259 OID 128764)
-- Dependencies: 5 1301
-- Name: alert_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE alert_nsuk_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.alert_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1788 (class 0 OID 0)
-- Dependencies: 1308
-- Name: alert_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE alert_nsuk_seq OWNED BY alert.nsuk;


--
-- TOC entry 1309 (class 1259 OID 128766)
-- Dependencies: 1672 5
-- Name: alert_operator; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE alert_operator (
    nsuk integer NOT NULL,
    operator character varying(16) NOT NULL,
    range_ok character(1) DEFAULT 'N'::bpchar NOT NULL
);


ALTER TABLE public.alert_operator OWNER TO postgres;

--
-- TOC entry 1310 (class 1259 OID 128769)
-- Dependencies: 5 1309
-- Name: alert_operator_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE alert_operator_nsuk_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.alert_operator_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1789 (class 0 OID 0)
-- Dependencies: 1310
-- Name: alert_operator_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE alert_operator_nsuk_seq OWNED BY alert_operator.nsuk;


--
-- TOC entry 1311 (class 1259 OID 128771)
-- Dependencies: 5
-- Name: alert_raised; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE alert_raised (
    nsuk integer NOT NULL,
    alert_id integer NOT NULL,
    transaction_id integer,
    time_raised timestamp without time zone NOT NULL
);


ALTER TABLE public.alert_raised OWNER TO postgres;

--
-- TOC entry 1312 (class 1259 OID 128773)
-- Dependencies: 1311 5
-- Name: alert_raised_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE alert_raised_nsuk_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.alert_raised_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1790 (class 0 OID 0)
-- Dependencies: 1312
-- Name: alert_raised_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE alert_raised_nsuk_seq OWNED BY alert_raised.nsuk;


--
-- TOC entry 1313 (class 1259 OID 128775)
-- Dependencies: 1675 5
-- Name: alert_subscription; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE alert_subscription (
    user_id integer NOT NULL,
    alert_id integer NOT NULL,
    deleted character(1) DEFAULT 'N'::bpchar NOT NULL,
    created timestamp without time zone NOT NULL,
    updated timestamp without time zone NOT NULL
);


ALTER TABLE public.alert_subscription OWNER TO postgres;

--
-- TOC entry 1314 (class 1259 OID 128778)
-- Dependencies: 5
-- Name: alert_type; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE alert_type (
    nsuk integer NOT NULL,
    alert character varying(16) NOT NULL,
    description character varying(64),
    type_code integer NOT NULL
);


ALTER TABLE public.alert_type OWNER TO postgres;

--
-- TOC entry 1315 (class 1259 OID 128780)
-- Dependencies: 5 1314
-- Name: alert_type_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE alert_type_nsuk_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.alert_type_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1791 (class 0 OID 0)
-- Dependencies: 1315
-- Name: alert_type_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE alert_type_nsuk_seq OWNED BY alert_type.nsuk;


--
-- TOC entry 1316 (class 1259 OID 128782)
-- Dependencies: 1677 5
-- Name: camera; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE camera (
    nsuk integer NOT NULL,
    dvr_id integer,
    channel_no integer NOT NULL,
    name character varying(32) NOT NULL,
    counter_id integer,
    deleted character(1) DEFAULT 'N'::bpchar NOT NULL,
    created timestamp without time zone NOT NULL,
    updated timestamp without time zone NOT NULL
);


ALTER TABLE public.camera OWNER TO postgres;

--
-- TOC entry 1317 (class 1259 OID 128785)
-- Dependencies: 5 1316
-- Name: camera_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE camera_nsuk_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.camera_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1792 (class 0 OID 0)
-- Dependencies: 1317
-- Name: camera_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE camera_nsuk_seq OWNED BY camera.nsuk;


--
-- TOC entry 1318 (class 1259 OID 128787)
-- Dependencies: 1679 5
-- Name: counter; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE counter (
    nsuk integer NOT NULL,
    term_no text NOT NULL,
    description character varying(64) NOT NULL,
    deleted character(1) DEFAULT 'N'::bpchar NOT NULL,
    created timestamp without time zone NOT NULL,
    updated timestamp without time zone NOT NULL
);


ALTER TABLE public.counter OWNER TO postgres;

--
-- TOC entry 1319 (class 1259 OID 128790)
-- Dependencies: 5 1318
-- Name: counter_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE counter_nsuk_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.counter_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1793 (class 0 OID 0)
-- Dependencies: 1319
-- Name: counter_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE counter_nsuk_seq OWNED BY counter.nsuk;


--
-- TOC entry 1320 (class 1259 OID 128792)
-- Dependencies: 1681 1682 5
-- Name: dvr; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE dvr (
    nsuk integer NOT NULL,
    name character varying(32) NOT NULL,
    ip_addr character varying(16) NOT NULL,
    port integer DEFAULT 8000 NOT NULL,
    username character varying(16) NOT NULL,
    password character varying(16),
    deleted character(1) DEFAULT 'N'::bpchar NOT NULL,
    created timestamp without time zone NOT NULL,
    updated timestamp without time zone NOT NULL,
    dvr_no integer NOT NULL
);


ALTER TABLE public.dvr OWNER TO postgres;

--
-- TOC entry 1321 (class 1259 OID 128796)
-- Dependencies: 5 1320
-- Name: dvr_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE dvr_nsuk_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.dvr_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1794 (class 0 OID 0)
-- Dependencies: 1321
-- Name: dvr_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE dvr_nsuk_seq OWNED BY dvr.nsuk;


--
-- TOC entry 1322 (class 1259 OID 128798)
-- Dependencies: 5
-- Name: role; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE role (
    nsuk integer NOT NULL,
    role character varying(16) NOT NULL,
    description character varying(64),
    created timestamp without time zone NOT NULL,
    updated timestamp without time zone NOT NULL
);


ALTER TABLE public.role OWNER TO postgres;

--
-- TOC entry 1323 (class 1259 OID 128800)
-- Dependencies: 5 1322
-- Name: role_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE role_nsuk_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.role_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1795 (class 0 OID 0)
-- Dependencies: 1323
-- Name: role_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE role_nsuk_seq OWNED BY role.nsuk;


--
-- TOC entry 1324 (class 1259 OID 128802)
-- Dependencies: 5
-- Name: sys_param; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE sys_param (
    param character varying(32) NOT NULL,
    type_id integer NOT NULL,
    value character varying(64),
    description character varying(64)
);


ALTER TABLE public.sys_param OWNER TO postgres;

--
-- TOC entry 1325 (class 1259 OID 128804)
-- Dependencies: 5
-- Name: sys_param_type; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE sys_param_type (
    nsuk integer NOT NULL,
    type character varying(16) NOT NULL
);


ALTER TABLE public.sys_param_type OWNER TO postgres;

--
-- TOC entry 1326 (class 1259 OID 128806)
-- Dependencies: 5 1325
-- Name: sys_param_type_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE sys_param_type_nsuk_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.sys_param_type_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1796 (class 0 OID 0)
-- Dependencies: 1326
-- Name: sys_param_type_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE sys_param_type_nsuk_seq OWNED BY sys_param_type.nsuk;


--
-- TOC entry 1327 (class 1259 OID 128808)
-- Dependencies: 1686 5
-- Name: teller; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE teller (
    nsuk integer NOT NULL,
    teller_no text NOT NULL,
    name character varying(64) NOT NULL,
    deleted character(1) DEFAULT 'N'::bpchar NOT NULL,
    created timestamp without time zone NOT NULL,
    updated timestamp without time zone NOT NULL
);


ALTER TABLE public.teller OWNER TO postgres;

--
-- TOC entry 1328 (class 1259 OID 128811)
-- Dependencies: 5 1327
-- Name: teller_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE teller_nsuk_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.teller_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1797 (class 0 OID 0)
-- Dependencies: 1328
-- Name: teller_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE teller_nsuk_seq OWNED BY teller.nsuk;


--
-- TOC entry 1329 (class 1259 OID 128813)
-- Dependencies: 1688 5
-- Name: transaction; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE transaction (
    nsuk integer NOT NULL,
    member_no character varying(9) NOT NULL,
    member_name character varying(32) NOT NULL,
    counter_id integer NOT NULL,
    teller_id integer NOT NULL,
    transaction_type character varying(15),
    total numeric(16,2) NOT NULL,
    tendered numeric(16,2),
    change numeric(16,2),
    wd_chq_amount numeric(16,2),
    wd_cash_amount numeric(16,2),
    trans_time timestamp without time zone NOT NULL,
    processed character(1) DEFAULT 'N'::bpchar NOT NULL,
    created timestamp without time zone NOT NULL
);


ALTER TABLE public.transaction OWNER TO postgres;

--
-- TOC entry 1330 (class 1259 OID 128816)
-- Dependencies: 5 1329
-- Name: transaction_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE transaction_nsuk_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.transaction_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1798 (class 0 OID 0)
-- Dependencies: 1330
-- Name: transaction_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE transaction_nsuk_seq OWNED BY transaction.nsuk;


--
-- TOC entry 1331 (class 1259 OID 128818)
-- Dependencies: 1690 1691 5
-- Name: user; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE "user" (
    nsuk integer NOT NULL,
    username character varying(16) NOT NULL,
    password character varying(32) NOT NULL,
    firstname character varying(32) NOT NULL,
    lastname character varying(64),
    active character(1) DEFAULT 'Y'::bpchar NOT NULL,
    deleted character(1) DEFAULT 'N'::bpchar NOT NULL,
    created timestamp without time zone NOT NULL,
    updated timestamp without time zone NOT NULL
);


ALTER TABLE public."user" OWNER TO postgres;

--
-- TOC entry 1332 (class 1259 OID 128822)
-- Dependencies: 5 1331
-- Name: user_nsuk_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE user_nsuk_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.user_nsuk_seq OWNER TO postgres;

--
-- TOC entry 1799 (class 0 OID 0)
-- Dependencies: 1332
-- Name: user_nsuk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE user_nsuk_seq OWNED BY "user".nsuk;


--
-- TOC entry 1333 (class 1259 OID 128824)
-- Dependencies: 5
-- Name: user_role_map; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE user_role_map (
    user_id integer NOT NULL,
    role_id integer NOT NULL
);


ALTER TABLE public.user_role_map OWNER TO postgres;

--
-- TOC entry 1666 (class 2604 OID 128826)
-- Dependencies: 1308 1301
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE alert ALTER COLUMN nsuk SET DEFAULT nextval('alert_nsuk_seq'::regclass);


--
-- TOC entry 1667 (class 2604 OID 128827)
-- Dependencies: 1303 1302
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE alert_bool ALTER COLUMN nsuk SET DEFAULT nextval('alert_bool_nsuk_seq'::regclass);


--
-- TOC entry 1670 (class 2604 OID 128828)
-- Dependencies: 1305 1304
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE alert_clause ALTER COLUMN nsuk SET DEFAULT nextval('alert_clause_nsuk_seq'::regclass);


--
-- TOC entry 1671 (class 2604 OID 128829)
-- Dependencies: 1307 1306
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE alert_message ALTER COLUMN nsuk SET DEFAULT nextval('alert_message_nsuk_seq'::regclass);


--
-- TOC entry 1673 (class 2604 OID 128830)
-- Dependencies: 1310 1309
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE alert_operator ALTER COLUMN nsuk SET DEFAULT nextval('alert_operator_nsuk_seq'::regclass);


--
-- TOC entry 1674 (class 2604 OID 128831)
-- Dependencies: 1312 1311
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE alert_raised ALTER COLUMN nsuk SET DEFAULT nextval('alert_raised_nsuk_seq'::regclass);


--
-- TOC entry 1676 (class 2604 OID 128832)
-- Dependencies: 1315 1314
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE alert_type ALTER COLUMN nsuk SET DEFAULT nextval('alert_type_nsuk_seq'::regclass);


--
-- TOC entry 1678 (class 2604 OID 128833)
-- Dependencies: 1317 1316
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE camera ALTER COLUMN nsuk SET DEFAULT nextval('camera_nsuk_seq'::regclass);


--
-- TOC entry 1680 (class 2604 OID 128834)
-- Dependencies: 1319 1318
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE counter ALTER COLUMN nsuk SET DEFAULT nextval('counter_nsuk_seq'::regclass);


--
-- TOC entry 1683 (class 2604 OID 128835)
-- Dependencies: 1321 1320
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE dvr ALTER COLUMN nsuk SET DEFAULT nextval('dvr_nsuk_seq'::regclass);


--
-- TOC entry 1684 (class 2604 OID 128836)
-- Dependencies: 1323 1322
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE role ALTER COLUMN nsuk SET DEFAULT nextval('role_nsuk_seq'::regclass);


--
-- TOC entry 1685 (class 2604 OID 128837)
-- Dependencies: 1326 1325
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE sys_param_type ALTER COLUMN nsuk SET DEFAULT nextval('sys_param_type_nsuk_seq'::regclass);


--
-- TOC entry 1687 (class 2604 OID 128838)
-- Dependencies: 1328 1327
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE teller ALTER COLUMN nsuk SET DEFAULT nextval('teller_nsuk_seq'::regclass);


--
-- TOC entry 1689 (class 2604 OID 128839)
-- Dependencies: 1330 1329
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE transaction ALTER COLUMN nsuk SET DEFAULT nextval('transaction_nsuk_seq'::regclass);


--
-- TOC entry 1692 (class 2604 OID 128840)
-- Dependencies: 1332 1331
-- Name: nsuk; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE "user" ALTER COLUMN nsuk SET DEFAULT nextval('user_nsuk_seq'::regclass);


--
-- TOC entry 1698 (class 2606 OID 128842)
-- Dependencies: 1302 1302
-- Name: alert_bool_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_bool
    ADD CONSTRAINT alert_bool_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1700 (class 2606 OID 128844)
-- Dependencies: 1302 1302
-- Name: alert_bool_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_bool
    ADD CONSTRAINT alert_bool_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1702 (class 2606 OID 128846)
-- Dependencies: 1304 1304
-- Name: alert_clause_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_clause
    ADD CONSTRAINT alert_clause_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1704 (class 2606 OID 128848)
-- Dependencies: 1304 1304
-- Name: alert_clause_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_clause
    ADD CONSTRAINT alert_clause_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1706 (class 2606 OID 128850)
-- Dependencies: 1306 1306
-- Name: alert_message_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_message
    ADD CONSTRAINT alert_message_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1708 (class 2606 OID 128852)
-- Dependencies: 1306 1306
-- Name: alert_message_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_message
    ADD CONSTRAINT alert_message_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1694 (class 2606 OID 128854)
-- Dependencies: 1301 1301
-- Name: alert_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert
    ADD CONSTRAINT alert_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1710 (class 2606 OID 128856)
-- Dependencies: 1309 1309
-- Name: alert_operator_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_operator
    ADD CONSTRAINT alert_operator_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1712 (class 2606 OID 128858)
-- Dependencies: 1309 1309
-- Name: alert_operator_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_operator
    ADD CONSTRAINT alert_operator_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1696 (class 2606 OID 128860)
-- Dependencies: 1301 1301
-- Name: alert_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert
    ADD CONSTRAINT alert_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1714 (class 2606 OID 128862)
-- Dependencies: 1311 1311
-- Name: alert_raised_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_raised
    ADD CONSTRAINT alert_raised_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1716 (class 2606 OID 128864)
-- Dependencies: 1311 1311
-- Name: alert_raised_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_raised
    ADD CONSTRAINT alert_raised_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1718 (class 2606 OID 128866)
-- Dependencies: 1313 1313 1313
-- Name: alert_subscription_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_subscription
    ADD CONSTRAINT alert_subscription_pkey PRIMARY KEY (user_id, alert_id);


--
-- TOC entry 1720 (class 2606 OID 128868)
-- Dependencies: 1314 1314
-- Name: alert_type_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_type
    ADD CONSTRAINT alert_type_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1722 (class 2606 OID 128870)
-- Dependencies: 1314 1314
-- Name: alert_type_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alert_type
    ADD CONSTRAINT alert_type_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1724 (class 2606 OID 128872)
-- Dependencies: 1316 1316
-- Name: camera_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY camera
    ADD CONSTRAINT camera_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1726 (class 2606 OID 128874)
-- Dependencies: 1316 1316
-- Name: camera_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY camera
    ADD CONSTRAINT camera_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1728 (class 2606 OID 128876)
-- Dependencies: 1318 1318
-- Name: counter_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY counter
    ADD CONSTRAINT counter_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1730 (class 2606 OID 128878)
-- Dependencies: 1318 1318
-- Name: counter_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY counter
    ADD CONSTRAINT counter_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1732 (class 2606 OID 128880)
-- Dependencies: 1320 1320
-- Name: dvr_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dvr
    ADD CONSTRAINT dvr_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1734 (class 2606 OID 128882)
-- Dependencies: 1320 1320
-- Name: dvr_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dvr
    ADD CONSTRAINT dvr_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1736 (class 2606 OID 128884)
-- Dependencies: 1322 1322
-- Name: role_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY role
    ADD CONSTRAINT role_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1738 (class 2606 OID 128886)
-- Dependencies: 1322 1322
-- Name: role_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY role
    ADD CONSTRAINT role_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1740 (class 2606 OID 128888)
-- Dependencies: 1322 1322
-- Name: role_role_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY role
    ADD CONSTRAINT role_role_key UNIQUE (role);


--
-- TOC entry 1742 (class 2606 OID 128890)
-- Dependencies: 1324 1324
-- Name: sys_param_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY sys_param
    ADD CONSTRAINT sys_param_pkey PRIMARY KEY (param);


--
-- TOC entry 1744 (class 2606 OID 128892)
-- Dependencies: 1325 1325
-- Name: sys_param_type_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY sys_param_type
    ADD CONSTRAINT sys_param_type_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1746 (class 2606 OID 128894)
-- Dependencies: 1325 1325
-- Name: sys_param_type_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY sys_param_type
    ADD CONSTRAINT sys_param_type_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1748 (class 2606 OID 128896)
-- Dependencies: 1327 1327
-- Name: teller_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY teller
    ADD CONSTRAINT teller_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1750 (class 2606 OID 128898)
-- Dependencies: 1327 1327
-- Name: teller_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY teller
    ADD CONSTRAINT teller_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1752 (class 2606 OID 128900)
-- Dependencies: 1329 1329
-- Name: transaction_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY transaction
    ADD CONSTRAINT transaction_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1754 (class 2606 OID 128902)
-- Dependencies: 1329 1329
-- Name: transaction_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY transaction
    ADD CONSTRAINT transaction_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1757 (class 2606 OID 128904)
-- Dependencies: 1331 1331
-- Name: user_nsuk_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY "user"
    ADD CONSTRAINT user_nsuk_key UNIQUE (nsuk);


--
-- TOC entry 1759 (class 2606 OID 128906)
-- Dependencies: 1331 1331
-- Name: user_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY "user"
    ADD CONSTRAINT user_pkey PRIMARY KEY (nsuk);


--
-- TOC entry 1761 (class 2606 OID 128908)
-- Dependencies: 1333 1333 1333
-- Name: user_role_map_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY user_role_map
    ADD CONSTRAINT user_role_map_pkey PRIMARY KEY (user_id, role_id);


--
-- TOC entry 1755 (class 1259 OID 128909)
-- Dependencies: 1331
-- Name: I_User_username; Type: INDEX; Schema: public; Owner: postgres; Tablespace: 
--

CREATE INDEX "I_User_username" ON "user" USING btree (username);


--
-- TOC entry 1763 (class 2606 OID 128910)
-- Dependencies: 1304 1302 1697
-- Name: alert_clause_alert_bool_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY alert_clause
    ADD CONSTRAINT alert_clause_alert_bool_id_fkey FOREIGN KEY (alert_bool_id) REFERENCES alert_bool(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1764 (class 2606 OID 128915)
-- Dependencies: 1304 1301 1693
-- Name: alert_clause_alert_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY alert_clause
    ADD CONSTRAINT alert_clause_alert_id_fkey FOREIGN KEY (alert_id) REFERENCES alert(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1765 (class 2606 OID 128920)
-- Dependencies: 1304 1709 1309
-- Name: alert_clause_operator_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY alert_clause
    ADD CONSTRAINT alert_clause_operator_id_fkey FOREIGN KEY (operator_id) REFERENCES alert_operator(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1766 (class 2606 OID 128925)
-- Dependencies: 1719 1304 1314
-- Name: alert_clause_type_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY alert_clause
    ADD CONSTRAINT alert_clause_type_id_fkey FOREIGN KEY (type_id) REFERENCES alert_type(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1762 (class 2606 OID 128930)
-- Dependencies: 1301 1756 1331
-- Name: alert_created_by_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY alert
    ADD CONSTRAINT alert_created_by_id_fkey FOREIGN KEY (created_by_id) REFERENCES "user"(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1767 (class 2606 OID 128935)
-- Dependencies: 1306 1311 1713
-- Name: alert_message_alert_raised_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY alert_message
    ADD CONSTRAINT alert_message_alert_raised_id_fkey FOREIGN KEY (alert_raised_id) REFERENCES alert_raised(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1768 (class 2606 OID 128940)
-- Dependencies: 1331 1306 1756
-- Name: alert_message_recipient_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY alert_message
    ADD CONSTRAINT alert_message_recipient_id_fkey FOREIGN KEY (recipient_id) REFERENCES "user"(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1769 (class 2606 OID 128945)
-- Dependencies: 1311 1301 1693
-- Name: alert_raised_alert_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY alert_raised
    ADD CONSTRAINT alert_raised_alert_id_fkey FOREIGN KEY (alert_id) REFERENCES alert(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1770 (class 2606 OID 128950)
-- Dependencies: 1311 1329 1751
-- Name: alert_raised_transaction_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY alert_raised
    ADD CONSTRAINT alert_raised_transaction_id_fkey FOREIGN KEY (transaction_id) REFERENCES "transaction"(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1771 (class 2606 OID 128955)
-- Dependencies: 1313 1301 1693
-- Name: alert_subscription_alert_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY alert_subscription
    ADD CONSTRAINT alert_subscription_alert_id_fkey FOREIGN KEY (alert_id) REFERENCES alert(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1772 (class 2606 OID 128960)
-- Dependencies: 1756 1331 1313
-- Name: alert_subscription_user_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY alert_subscription
    ADD CONSTRAINT alert_subscription_user_id_fkey FOREIGN KEY (user_id) REFERENCES "user"(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1773 (class 2606 OID 128965)
-- Dependencies: 1316 1318 1727
-- Name: camera_counter_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY camera
    ADD CONSTRAINT camera_counter_id_fkey FOREIGN KEY (counter_id) REFERENCES counter(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1774 (class 2606 OID 128970)
-- Dependencies: 1731 1316 1320
-- Name: camera_dvr_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY camera
    ADD CONSTRAINT camera_dvr_id_fkey FOREIGN KEY (dvr_id) REFERENCES dvr(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1775 (class 2606 OID 128975)
-- Dependencies: 1325 1324 1743
-- Name: sys_param_type_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY sys_param
    ADD CONSTRAINT sys_param_type_id_fkey FOREIGN KEY (type_id) REFERENCES sys_param_type(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1776 (class 2606 OID 128980)
-- Dependencies: 1318 1329 1727
-- Name: transaction_counter_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY transaction
    ADD CONSTRAINT transaction_counter_id_fkey FOREIGN KEY (counter_id) REFERENCES counter(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1777 (class 2606 OID 128985)
-- Dependencies: 1327 1329 1747
-- Name: transaction_teller_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY transaction
    ADD CONSTRAINT transaction_teller_id_fkey FOREIGN KEY (teller_id) REFERENCES teller(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1778 (class 2606 OID 128990)
-- Dependencies: 1322 1333 1735
-- Name: user_role_map_role_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY user_role_map
    ADD CONSTRAINT user_role_map_role_id_fkey FOREIGN KEY (role_id) REFERENCES "role"(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1779 (class 2606 OID 128995)
-- Dependencies: 1756 1333 1331
-- Name: user_role_map_user_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY user_role_map
    ADD CONSTRAINT user_role_map_user_id_fkey FOREIGN KEY (user_id) REFERENCES "user"(nsuk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 1784 (class 0 OID 0)
-- Dependencies: 5
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


-- Completed on 2010-08-30 15:33:06

--
-- PostgreSQL database dump complete
--

