
-- speed up return product search
create index codet2 on codetail (product_type,location,contract);

-- Function: vnrbld_custaged_at(date, integer, integer)

-- DROP FUNCTION vnrbld_custaged_at(date, integer, integer);

CREATE OR REPLACE FUNCTION vnrbld_custaged_at(p_date date, p_reverse integer, p_age_credits integer)
  RETURNS sp_status AS
$BODY$
declare p_index int;
        w_count int;
        ---p_slave_depot int;
        ---p_slave_cust char(7);
        p_ledger_mnth dparams.period%type;
        current_period dparams.period%type;
        PaccountType cust.account_type%type;
        current_unalloc cust.unallocated%type;
        current_balance cust.balance%type;
        ageing jp_custage;
        slave_age jp_custage;
        p_cust record;
        p_slave record;
        w_stat char(5);
        err sp_status;
        dc_count integer;
	p_vat_rate vat.rate%type;

begin

    select rate into p_vat_rate
        from vat where cod = 1;

    select * from jp_period(p_date) into current_period;    -- Convert date to beginning of month;

    -- this is a simple protection - but why is it needed?
    update cust set account_type = 'C'
        where account_type not in ('A','C');
    update cust set account_type = 'C'
        where account_type is null;

    delete from cust_age
        where period = current_period;

    <<customer_loop>>
    for p_cust in select depot, cod, bad_debt, suspend
        from cust
    loop

        -- handle null Suspend fields
    if p_cust.suspend is null then
       p_cust.suspend := 'N';
        end if;

        if p_cust.bad_debt is null then
            p_cust.bad_debt := 'N';
        end if;

    -- if the account is a slave account, we will process it within
        -- the account group

        select count(*)
        into w_count
        from account_groups
        where  slave_depot = p_cust.depot
          and  slave_cust = p_cust.cod;

        if w_count > 0 then
            continue customer_loop;
        end if;

        select count(*)
        into w_count
        from account_groups
        where master_depot = p_cust.depot
          and master_cust = p_cust.cod;

        if w_count = 0 then
            select * from vncustaged_at(p_cust.depot, p_cust.cod, p_date, p_reverse, p_age_credits,p_vat_rate)
             into ageing;

            insert into cust_age (period, depot, cod, slave_depot, slave_cod,
                                  balance, unallocated, lastpay, lastpaid,
                                  account_type, suspend, bad_debt,
                                  current, age1, age2, age3, age4, age5,
                                  master_slave, slave_count)

           values (current_period, ageing.depot, ageing.cust, ageing.depot,  ageing.cust,
                  ageing.balance, ageing.unallocated, ageing.last_pay, ageing.last_paid,
                  ageing.account_type, p_cust.suspend, ageing.bad_debt,
                  ageing.curr_bal, ageing.per1_bal, ageing.per2_bal,
                  ageing.per3_bal, ageing.per4_bal, ageing.per5_bal, 'M', 0);


        else
	    --
	    --	return master details first
	    --
            select * from vncustaged_at(p_cust.depot, p_cust.cod, p_date,
                                      p_reverse, p_age_credits , p_vat_rate)
                   into ageing;

            insert into cust_age (period, depot, cod, slave_depot, slave_cod,
                                  balance, unallocated, lastpay, lastpaid,
                                  account_type, suspend, bad_debt,
                                  current, age1, age2, age3, age4, age5,
                                  master_slave, slave_count)

           values (current_period, ageing.depot, ageing.cust, ageing.depot, ageing.cust,
                  ageing.balance, ageing.unallocated, ageing.last_pay, ageing.last_paid,
                  ageing.account_type, p_cust.suspend, ageing.bad_debt,
                  ageing.curr_bal, ageing.per1_bal, ageing.per2_bal,
                  ageing.per3_bal, ageing.per4_bal, ageing.per5_bal, 'M', 0);

            for p_slave in select slave_depot, slave_cust, bad_debt, suspend
               from account_groups, cust
              where master_depot = ageing.depot
	        and master_cust = ageing.cust
                and slave_depot = cust.depot
                and slave_cust = cust.cod
             loop

                select * from vncustaged_at(p_slave.slave_depot, p_slave.slave_cust,
		                 p_date, p_reverse, p_age_credits,p_vat_rate) into slave_age;

                insert into cust_age(period, depot, cod, slave_depot, slave_cod,
                                     balance, unallocated, lastpay, lastpaid,
                                     account_type, suspend, bad_debt,
                                     current, age1, age2, age3, age4, age5,
                                     master_slave, slave_count)

               values (current_period,ageing.depot,ageing.cust,slave_age.depot,slave_age.cust,
                       slave_age.balance, slave_age.unallocated, slave_age.last_pay, slave_age.last_paid,
                       slave_age.account_type, p_slave.suspend, slave_age.bad_debt,
                       slave_age.curr_bal, slave_age.per1_bal, slave_age.per2_bal,
                       slave_age.per3_bal, slave_age.per4_bal, slave_age.per5_bal, 'S', 0);

             end loop;
          end if;
       end loop customer_loop;

       err.ret_stat := 0;
       err.ret_string := 'Success';
       return err;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION vnrbld_custaged_at(date, integer, integer) OWNER TO postgres;


-- Function: vncustaged_at(integer, text, date, integer, integer, numeric)

-- DROP FUNCTION vncustaged_at(integer, text, date, integer, integer, numeric);

CREATE OR REPLACE FUNCTION vncustaged_at(p_depot integer, p_cod text, p_date date, p_reverse integer, p_age_credits integer, p_vat_rate numeric)
  RETURNS jp_custage AS
$BODY$
declare p_index int;
        p_time_interval interval;
        p_ledger_mnth dparams.period%type;
        p_current_Period dparams.period%type;
        p_age decimal(16,2)[6];
        Pamount sledger.amount%type;
        Palloc sledger.os%type;
        Punallocated cust.unallocated%type;
        PaccountType cust.account_type%type;
        Pbalance cust.balance%type;
        Pbad_debt char;
        PlastPay cust.last_pay%type;
        PlastPaid cust.last_paid%type;
        p_period_cutoff sledger.period%type;
        g_period pledger.period%type;
        ledger_row record;
        return_age jp_custage;
        ts1 timestamp;
        ts2 timestamp;
        i integer;
        work_date date;
        operation_mode integer;
        old_mode integer := 1;
        new_mode integer := 2;
        Pvat sledger.vat%type;

declare test refcursor;
begin

  raise notice 'Building %', P_cod;

  operation_mode := new_mode;

  select account_type, bad_debt
  into PaccountType, Pbad_debt
  from cust
  where cust.depot = P_depot
    and cust.cod = P_cod;

  if PaccountType is null then
      PaccountType := 'C';
  end if;

  ts1 := p_date;
  ts2 := ts1 - interval '5 months';
  work_date := ts2;
  p_period_cutoff := jp_period(work_date);
  p_current_period := jp_period(p_date);


  return_age.depot = p_depot;
  return_age.cust = p_cod;
  return_age.balance := 0;
  return_age.unallocated := 0;
  return_age.last_pay := null;
  return_age.last_paid := null;

  if operation_mode = new_mode then
      return_age.bad_debt := 'N';
  else
      return_age.bad_debt := Pbad_debt;
  end if;

  for i in 1 .. 6
  loop
      p_age[i] := 0.00;
  end loop;
  Palloc := 0.00;


  /*<<ledger_loop>>
  for ledger_row in
     select ser, typ, dat, amount, os, period
     from sledger
     where depot = p_depot and cod = p_cod
     order by dat, ser
*/
  open test FOR EXECUTE 'SELECT ser, typ, dat, amount, os, period  FROM  sledger ' ||
  		       ' where depot = ' || p_depot ||
		       ' and cod = ' || quote_literal( p_cod ) ||
                       ' order by dat,ser ';

  <<ledger_loop>>
  loop
     fetch test into ledger_row;

     if not found then
	exit;
     end if;


     if p_reverse = 1 then
         if ledger_row.period > p_date then
             continue ledger_loop;
         end if;

         if ledger_row.typ < 10 then
             select sum(ee.amount + ee.discount)
             into Palloc
             from sallocee ee, sallocper per
             where ee.ee = ledger_row.ser
             and ee.allocation = per.allocation
             and per.period > p_date;

         else
             select sum(er.amount)
             into Palloc
             from sallocer er, sallocper per
             where er.er = ledger_row.ser
             and er.allocation = per.allocation
             and per.period > p_date;

         end if;

         -- If the alloc amount is null set it to zero
         IF Palloc is null then
             Palloc := 0.00;
         end if;
     end if;

     if ledger_row.typ = 13 then
         return_age.last_pay  := ledger_row.amount;
         return_age.last_paid := ledger_row.dat;
     end if;

     if operation_mode = new_mode then
         if ledger_row.typ = 16 then
             return_age.bad_debt = 'Y';
             continue;
         end if;
      end if;

     if operation_mode = new_mode then
         if ledger_row.typ = 18 then
             return_age.bad_debt = 'N';
             continue;
         end if;
     end if;

     --p_ledger_mnth := '1/1/2006';

     if Ptyp <> 2 or Ptyp <> 12 then
         Pvat := ledger_row.amount - ((ledger_row.amount / (100 + p_vat_rate) ) * 100);
     end if;



     p_ledger_mnth := jp_period(ledger_row.dat);

     if operation_mode = new_mode then
         return_age.balance := return_age.balance + ledger_row.amount;
     end if;

     if ledger_row.typ < 10 then
         ledger_row.os := ledger_row.os + Palloc;

 	 if ledger_row.os <> 0 then
	        ledger_row.os := (ledger_row.os * (ledger_row.amount - Pvat)) / ledger_row.amount;
	 end if;



         if operation_mode = old_mode then
            return_age.balance := return_age.balance + ledger_row.os;
         end if;

     else
         ledger_row.os := ledger_row.os + Palloc;

 	 if ledger_row.os <> 0 then
	        ledger_row.os := (ledger_row.os * (ledger_row.amount - Pvat)) / ledger_row.amount;
	 end if;

         if operation_mode = old_mode then
            return_age.balance := return_age.balance - ledger_row.os;
         end if;

         return_age.unallocated := return_age.unallocated + ledger_row.os;


         ledger_row.os := 0 - ledger_row.os;
         if p_age_credits = 0 then
            continue ledger_loop;
         end if;
     end if;

     -- Calculate the balance

     IF p_ledger_mnth is null then
         p_ledger_mnth := p_current_period;
     end if;

     IF p_ledger_mnth < p_period_cutoff then
         p_index := 6;
     else
         IF p_ledger_mnth > p_current_period then
             p_index := 1;
         else
             --p_index := 1;
             p_index := elapsed_months(p_ledger_mnth, p_current_period) + 1;
         end if;
     end if;

     if p_index = 0 then
        p_index := 1;
     end if;

     IF p_index > 6 THEN
         p_index := 6;
     END IF;

     p_age[p_index] := p_age[p_index] + ledger_row.os;

  end loop;

  close test;

  return_age.account_type := PaccountType;

  for i in 1 .. 6
  loop
    if i = 1 then
    return_age.curr_bal = p_age[i];
    elsif i = 2 then
    return_age.per1_bal = p_age[i];
    elsif i = 3 then
    return_age.per2_bal = p_age[i];
    elsif i = 4 then
    return_age.per3_bal = p_age[i];
    elsif i = 5 then
    return_age.per4_bal = p_age[i];
    elsif i = 6 then
    return_age.per5_bal = p_age[i];
    end if;
  end loop;

  RETURN return_age;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;

ALTER FUNCTION vncustaged_at(integer, text, date, integer, integer, numeric) OWNER TO postgres;


-- Function: analyse_slalloc(integer, text)

-- DROP FUNCTION analyse_slalloc(integer, text);

CREATE OR REPLACE FUNCTION analyse_slalloc(p_depot integer, p_cust text)
  RETURNS SETOF jp_audit AS
$BODY$
DECLARE
 alloc_row     record;
 er_row        record;
 ee_row        record;
 err           sp_status;
 audit_row     record;
 results       jp_audit;
BEGIN
      BEGIN          create table aud_slalloc(
           ser integer,
           typ integer,
           amount decimal(16,2),
           os decimal(16,2),
           allocated decimal(16,2),
           allocations decimal(16,2)
       );
   EXCEPTION
       when OTHERS then
           raise notice 'Table Already Exists';
   END;
                        insert INTO aud_slalloc(ser, typ, amount, os, allocated, allocations)
   select ser, 0 as typ, amount, os, case when (typ > 10 )
      then
         amount + os
	  else
		 amount - os
      end as allocated ,
	  amount as allocations
     from sledger
    where depot = p_depot
     and cod  = p_cust;

      update aud_slalloc set allocations = 0.00;

   for alloc_row in
    select allocation
      from sallocper
     where acdepot = p_depot
       and cust    = p_cust
   loop

       for er_row in select er, amount
	     from sallocer
         where sallocer.allocation = alloc_row.allocation
       loop
             update aud_slalloc
                set allocations = allocations - er_row.amount
              where aud_slalloc.ser = er_row.er;

       end loop;

       for ee_row in
        select ee, amount + discount    as alloc_amount
		from sallocee
          where sallocee.allocation = alloc_row.allocation
        loop
           update aud_slalloc
              set allocations = allocations + ee_row.alloc_amount
            where aud_slalloc.ser = ee_row.ee;

       end loop;

   end loop;
     for audit_row in select *
   --   into Pser, Ptyp, Pamount, Pos, Pallocated, Palloc_amount
   from aud_slalloc
  where allocated <> allocations
  loop

             results.seq := 13;
             results.msg1 := 'Unbalanced Allocation';
             results.v1 := audit_row.allocated;
             results.msg2 := 'Serial = ' || audit_row.ser;
             results.v2 := audit_row.allocations;
             results.diff := audit_row.allocated - audit_row.allocations;
             return next results;

   end loop;      delete from aud_slalloc;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE STRICT;
ALTER FUNCTION analyse_slalloc(integer, text) OWNER TO postgres;

CREATE OR REPLACE FUNCTION repair_slalloc(p_depot integer, p_cust text)
  RETURNS SETOF jp_audit AS
$BODY$
DECLARE
 alloc_row     record;
 er_row        record;
 ee_row        record;
 err           sp_status;
 audit_row     record;
 results       jp_audit;
BEGIN
      BEGIN          create table aud_slalloc(
           ser integer,
           typ integer,
           amount decimal(16,2),
           os decimal(16,2),
           allocated decimal(16,2),
           allocations decimal(16,2)
       );
   EXCEPTION
       when OTHERS then
           raise notice 'Table Already Exists';
   END;
                        insert INTO aud_slalloc(ser, typ, amount, os, allocated, allocations)
   select ser, 0 as typ, amount, os, case when (typ > 10 )
      then
         amount + os
	  else
		 amount - os
      end as allocated ,
	  amount as allocations
     from sledger
    where depot = p_depot
     and cod  = p_cust;

      update aud_slalloc set allocations = 0.00;

   for alloc_row in
    select allocation
      from sallocper
     where acdepot = p_depot
       and cust    = p_cust
   loop

       for er_row in select er, amount
	     from sallocer
         where sallocer.allocation = alloc_row.allocation
       loop
             update aud_slalloc
                set allocations = allocations - er_row.amount
              where aud_slalloc.ser = er_row.er;

       end loop;

       for ee_row in
        select ee, amount + discount    as alloc_amount
		from sallocee
          where sallocee.allocation = alloc_row.allocation
        loop
           update aud_slalloc
              set allocations = allocations + ee_row.alloc_amount
            where aud_slalloc.ser = ee_row.ee;

       end loop;

   end loop;
     for audit_row in select *
   --   into Pser, Ptyp, Pamount, Pos, Pallocated, Palloc_amount
   from aud_slalloc
  where allocated <> allocations
  loop
	  update sledger
	  set os = abs(audit_row.amount) - abs(audit_row.allocated)
	  where ser = audit_row.ser;

   end loop;
   delete from aud_slalloc;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE STRICT;
ALTER FUNCTION repair_slalloc(integer, text) OWNER TO postgres;


update dcssqlversion
set minor = 11,major = 8;

-- LOCKED OFF NOW NO NEW CHANGES


-- audit bugfixes

-- Function: audit()

-- DROP FUNCTION audit();

CREATE OR REPLACE FUNCTION audit()
  RETURNS SETOF jp_audit AS
$BODY$
declare	Psys_config_set		sys_config.set%type;
       	java_control_used	sys_config.set%type;
       	stationery	        sys_config.set%type;
       	stat_type	        sys_config.set%type;
       	Pnparams_current	nparams.current_period%type;
       	w_period		dparams.period%type;
       	Pparams_current		pparams.period%type;
        Pnparams_creditors	nparams.creditors%type;
       	msg1			char(30);
       	msg2			char(30);
       	msg3			char(30);
        v1			decimal(16,2);
       	v2			decimal(16,2);
       	v3			decimal(16,2);
       	v4			decimal(16,2);
       	w1			decimal(16,2);
       	a1			decimal(16,2);
       	b1			decimal(16,2);
       	c1			decimal(16,2);
       	w_java			decimal(16,2);
       	w_java_inv		decimal(16,2);
       	w_java_cr 		decimal(16,2);
       	w_vatsum 		decimal(16,2);
       	false			integer;
       	w_tmp			decimal(16,2);
       	tot_cost		decimal(16,2);
       	wk_cost			decimal(16,2);
       	v_cost			decimal(16,2);
       	unalloc_tot		decimal(16,2);
       	ledger_tot		decimal(16,2);
       	cr_notes		decimal(16,2);
       	invs    		decimal(16,2);
       	obal			decimal(16,2);
        cbal			decimal(16,2);
        trans			decimal(16,2);
	trans_tot		decimal(16,2);
       	Pnullcnt		integer;
       	diff			decimal(16,2);
        tot_depn		decimal(16,2);
        w_amount        decimal(16,2);
        w_os            decimal(16,2);

       	Pnlbals_cod		nlbals.cod%type;
       	Pnlbals_cc		nlbals.cc%type;
       	Pnlbals_period		nlbals.period%type;
       	Pnlbals_bop_bal		nlbals.bop_bal%type;
       	Pnlbals_cur_bal		nlbals.cur_bal%type;
       	Pnlbals_ytd_bal		nlbals.ytd_bal%type;

        ihead_row		ihead%rowtype;
        sanal_row		sanal%rowtype;
        nlbatch_row		nlbatch%rowtype;
        cust_row		cust%rowtype;
        supplier_row		supplier%rowtype;
        pledger_row		pledger%rowtype;
        asset_reg_row	        asset_reg%rowtype;
        nominal_row	        nominal%rowtype;
        chdetail_row		chdetail%rowtype;

        Pproduct_cost		product.cost%type;
	    results			jp_audit;
        w_ver           jp_verify;
        w_rows			integer;
        last_checkpoint record;
        w_today         date;
        sales_period    record;
        creditors_period record;
        found_checkpoint boolean;
        some_wild_date  date;
        debtors_nl_balance decimal(16,2);
        creditors_nl_balance decimal(16,2);
        err_code             integer;
        err_text             char(60);
        all_depots           integer;
        cust_check             record;
        alloc_row              record;
        run_mode               char(6);
        analsl_row             jp_audit;
		analpl_row             jp_audit;
		supplieranal_row		record;
begin

    false := 0;
    all_depots := 0;
    run_mode := 'detail';
    some_wild_date := now(); --'03/11/2053';

    perform * from nrbld_custaged_at(some_wild_date,0,0);
    perform * from nrbld_suppaged_at(some_wild_date,0,0,'FULL',0);

    java_control_used := 1;

    select current_period, creditors
    into Pnparams_current, Pnparams_creditors from nparams;

    select period into w_period from dparams;

    select period into Pparams_current from pparams;

-- 1.	Check Aged Debt Analysis Against Debtors in Nominal

     select sum(balance) into v1 from cust_age
     where period = jp_period(some_wild_date)
      and bad_debt = 'N';

    select sum(amount)
      into debtors_nl_balance
      from nltrans a, nparams b, reserved_ac c
     where (a.period >= b.boy_period -- All periods from beginning of year (inc CP)
            or
            a.tmp = 'Y' and dat >= b.boy_period ) and     --     Unposted batches
            a.cod = c.account_code and
            c.key_name = 'debtors';

    select sum(amount)
    into w_java
    from sledger
    where batch is null
      and cod is not null
      and source not in ('BR', 'BD')
      and period >= jp_period(some_wild_date);

    if (not FOUND) or (w_java is null) then
        w_java := 0.00;
    end if;

    v2 := debtors_nl_balance + w_java;

    msg1 := 'Aged Debt Analysis';

    msg2 := 'Nominal Debtors + JAVA TX';

    msg1 := 'Aged Debt Analysis';

    if w_java <> 0 then
       msg2 := 'Nominal Debtors + JAVA TX';
    else
       msg2 := 'Nominal Debtors';
    end if;

    results.seq := 1;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := v2;
    results.diff := v1 - v2;
    return next results;

-- 2. Check Aged Debt Analysis Against Sales Control Balance

    select * from sl_open_bal(some_wild_date, all_depots)
        into err_code, err_text, v2;

    select sum(amount)
       into trans_tot
       from sledger
      where period >= jp_period(some_wild_date)
        and cod is not null;

    if trans_tot is null then
	trans_tot := 0;
    end if;

    v2 := v2 + trans_tot;

    if v2 is null then
	    v2 := 0.00;
    end if;

    msg2 := 'Sales Ledger Control + JAVA TX';

    results.seq := 2;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := v2;
    results.diff := v1 - v2;

    return next results;

-- 2a. Check Nominal Debtors Against Sales Control


    msg1 := 'Nominal Debtors + JAVA TX';
    msg2 := 'Sales Ledger Control + JAVA TX';

--    v2 already has sales control figure

    v1 = debtors_nl_balance + w_java;


    results.seq := 2;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := v2;
    results.diff := v1 - v2;
    return next results;


-- 3.  Check Invoice Archive Headers against Sales Control

   --- Defunct

-- 4.  Check Invoice Archive Headers against Ledger Transactions

    select sum(tot)
    into v1
    from ihead
    where ihead.period = w_period
      and (ihead.doc_type = 'IN' or
           ihead.doc_type = 'CA');

    if (not FOUND) OR (v1 is null) then
        v1 := 0.00;
    end if;

    select sum(amount)
    into v2
    from sledger
    where sledger.typ = 2
      and sledger.period = w_period
      and sledger.cod is not null;

    if (not FOUND) or (v2 is null) then
	    v2 := 0.00;
    end if;

    msg1 := 'Invoices On Archive';
    msg2 := 'Ledger Transactions';

    results.seq := 4;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := v2;
    results.diff := v1 - v2;
    return next results;

-- 5.  Check Credit Note Archive Headers against Sales Control

  -- Defunct

-- 6.  Check Credit Note Archive Headers against Ledger Transactions

    select sum(tot)
    into v1
    from ihead
    where ihead.period = w_period
      and ihead.doc_type = 'CR';

    if v1 is null then
        v1 := 0.00;
    end if;


    select sum(amount)
    into v2
    from sledger
    where sledger.typ = 12
      and sledger.period = w_period
      and sledger.cod is not null;

    if v2 is null then
	    v2 := 0.00;
    end if;

    msg2 = 'Ledger Transactions';

    results.seq := 6;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := 0 - v2;
    results.diff := (v1 - (0 - v2));
    return next results;

-- 7.  Check Hire Details on Archive against Hire Sales Analysis

   -- Defunct

-- 8.  Check Consumable Details on Archive against Consumable Sales Analysis

    -- Defunct

-- 9. Check Cost of Consumable sales against sanal.qty sold * product.cost

    -- Defunct

-- 10.  Check Disposal Details on Archive against Disposal Sales Analysis

    -- Defunct


-- 11.  Check Disposal Details on Archive against Disposal Table

     select sum(b.goods)
      into v1
    from ihead a, iddetail b
    where a.doc_type = b.doc_type
      and a.location = b.location
      and a.ref = b.ref
      and a.cust = b.cust
      and a.period = w_period;

    if (not FOUND) or (v1 is null) then
	    v1 := 0.00;
    end if;

    select sum(qty * unit_sell)
    into a1
    from disposals
    where disposals.sales_period = w_period
    and qty > 0;

    if (not FOUND) or (a1 is null) then
	    a1 := 0.00;
    end if;

    select sum(qty * unit_sell)
    into b1
    from disposals
    where disposals.sales_period = w_period
    and qty < 0;

    if (not FOUND) or (b1 is null) then
	    b1 := 0.00;
    end if;

    v2 := a1 - b1;

    msg2 := 'Disposals List';
    results.seq := 11;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := v2;
    results.diff := v1 - v2;
    return next results;

-- 12.  Check for unbalanced batches

    msg1 := 'Unbalanced Batches';
    msg2 := null;
    v1 := null;

    for nlbatch_row in
        select *
        from nlbatch
        where stat <> 'I'		-- only those not yet updated
    loop

	    select sum(amount)
	    into w1
	    from nltrans
	    where nltrans.source = nlbatch_row.source
	      and nltrans.batch  = nlbatch_row.seq;

	    if w1 is null then
	        w1 := 0.00;
	    end if;

	    if w1 <> 0.00 then
	       msg2 := nlbatch_row.location || '/' || nlbatch_row.source || nlbatch_row.seq;
	       v2   := w1;
           results.seq := 12;
           results.msg1 := msg1;
           results.v1 := v1;
           results.msg2 := msg2;
           results.v2 := v1;
           results.diff := v2;
           return next results;
	    end if;

    end loop;

-- 13 / 14 / 15. Check for customer accounts out of balance.

    --
    -- Accounts are only out of balance if the sum of their amounts
    -- <> the sum of their os
    --

    msg1 := 'Unbalanced Debtor';
    msg3 := 'Unallocated Diff ';
    msg2 := null;
    v1 := null;

    for cust_check in
        select depot, cod, nam
        from cust
       where bad_debt = 'N'

    loop

        select sum(amount) as amount,
               sum(CASE WHEN (typ > 10 )
                            THEN (os * '-1.00')
                        ELSE os
                   END) as os
          into w_amount, w_os
          from sledger
          where depot = cust_check.depot
            and cod = cust_check.cod;

          if w_amount <> w_os then
              msg1 := 'Unbalanced Debtor ';
              msg2 := cust_check.depot || '/' || cust_check.cod;

              results.seq := 13;
              results.msg1 := msg1;
              results.v1 := w_amount;
              results.msg2 := msg2;
              results.v2 := w_os;
              results.diff := w_amount - w_os;
              return next results;

              if run_mode = 'detail' then

                  --
                  --  Since we have a difference analyse the allocations
                  --

                  for analsl_row in select * from analyse_slalloc(cust_check.depot,
                                                 cust_check.cod)
                  loop

                      return next analsl_row;

                  end loop;

              end if;

          end if;

    end loop;


-- 16. Check Sales VAT Analysis

--- Redundant


--		P U R C H A S E   L E D G E R


-- 17.  Check The Supplier Master Total Against the Balance On Nominal

    select sum(balance)
    into v1
    from supplier_age
    where period = jp_period(some_wild_date);

    select sum(amount)
      into creditors_nl_balance
      from nltrans a, nparams b
     where (a.period >= b.boy_period -- All periods from beginning of year (inc CP)
            or
            a.period is null and dat >= b.boy_period)
            and        --     Unposted batches
            a.cod in (
		select cod from nominal
		where parent in (
			select account_code from reserved_ac
			where reserved_ac.key_name = 'creditor_total')
			);

   v2 = creditors_nl_balance;

   v2 = 0 - v2;


   msg1 := 'Supplier Aged List';
   msg2 := 'Creditors Nominal + JAVA TX';


    results.seq := 17;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := v2;
    results.diff := v1 - v2;
    return next results;

-- 18.  Check Supplier List Against Control Account Total

    -- Sum of supplier.balance is in v1 from last query
    select * from pl_open_bal(some_wild_date)  into err_code, err_text, v2;

    select sum(amount)
        into w_java
    from pledger
    where period >= jp_period(some_wild_date)
    and supplier is not null;

    if (not FOUND) or (w_java is null) then
	w_java := 0.00;
    end if;

    v2 := v2 + w_java;

    if w_java <> 0 then
       msg1 := 'Supplier Aged List ';
       msg2 := 'Control Account Bal + JAVA TX';
    else
       msg1 := 'Supplier Aged List ';
       msg2 := 'Control Account Balance ';
    end if;

    --if java_control_used = false then

        results.seq := 18;
        results.msg1 := msg1;
        results.v1 := v1;
        results.msg2 := msg2;
        results.v2 := v2;
        results.diff := v1 - v2;
        return next results;
    --end if;

-- 19. Check Purchase VAT Analysis.

    msg1 := 'Purchase VAT Analysis';
    msg2 := 'Purchase Inv/Cr';

    w_vatsum := 0.00;

    select sum(pdetails.goods + pdetails.vat)
    into cr_notes
    from pdetails, pledger
    where pdetails.trans_ser = pledger.ser
      and pledger.period = Pparams_current
      and typ = 11;

    if cr_notes is null then
       cr_notes := 0.00;
    end if;

    cr_notes := 0.00 - cr_notes;

    select sum(pdetails.goods + pdetails.vat)
    into invs
    from pdetails, pledger
    where pdetails.trans_ser = pledger.ser
      and pledger.period = Pparams_current
      and typ = 2;

    if invs is null then
       invs := 0.00;
    end if;

    w_vatsum := cr_notes + invs;

    v1 := 0.00;

    select amount
    into v1
    from pledger
    where pledger.supplier is not  NULL
      and pledger.typ = 2
      and pledger.period = Pparams_current;

    v2 := 0.00;

    select amount
    into v2
    from pledger
    where pledger.supplier is not NULL
      and pledger.typ = 11
      and pledger.period = Pparams_current;

    v1 := v1 + v2;			-- v2 will be negative

    v1 := v1 + w_java;

    if w_java <> 0 then
       msg1 := 'Purchase VAT Analysis';
       msg2 := 'Purchase Inv/Cr + JAVA TX';
    else
       msg1 := 'Purchase VAT Analysis';
       msg2 := 'Purchase Inv/Cr';
    end if;


    --if java_control_used = false then

        results.seq := 19;
        results.msg1 := msg1;
        results.v1 := w_vatsum;
        results.msg2 := msg2;
        results.v2 := v1;
        results.diff := (w_vatsum - v1);
        return next results;
    --end if;

-- 20. Check Supplier Accounts Against Their Transactions

    for supplieranal_row in
	select supplier,sum(amount) as amount,sum(os) as os
	from pledger
	where supplier is not null
        group by 1
	having sum(amount) <> sum(os)
	loop

   	    msg1 := 'Unbalanced Creditor';
	    msg2 := supplieranal_row.supplier;


            results.seq := 20;
            results.msg1 := msg1;
            results.v1 := supplieranal_row.amount;
            results.msg2 := msg2;
            results.v2 := supplieranal_row.os;
            results.diff := supplieranal_row.amount - supplieranal_row.os;
            return next results;


              if run_mode = 'detail' then

                  --
                  --  Since we have a difference analyse the allocations
                  --

                  for analpl_row in select * from analyse_plalloc(supplieranal_row.supplier)
                  loop

                      return next analpl_row;

                  end loop;

              end if;
        end loop;

-- 21.  Check Purchase Control Vs Transactions

    if java_control_used = false then
        for pledger_row in
        select *
        from pledger
        where pledger.supplier is null
          and pledger.period = Pparams_current
          and pledger.typ <> 1
        loop

	    msg1 := get_ptrans(pledger_row.typ);
	    msg2 := 'Purchase Ledger Control';

	    select sum(amount) into v2
	    from pledger
	    where pledger.typ = pledger_row.typ and
	      pledger.period = Pparams_current and
	      pledger.supplier is not null;

	    if v2 is null then
	        v2 := 0.00;
	    end if;

            if pledger_row.typ = 11 then
                v2 := v2 + w_java_cr;
                msg2 := 'Purchase Ledger Control + JAVA TX';
            end if;

            if pledger_row.typ = 2 then
                v2 := v2 + w_java_inv;
                msg2 := 'Purchase Ledger Control + JAVA TX';
            end if;

	    v1 := pledger_row.amount;

            results.seq := 21;
            results.msg1 := msg1;
            results.v1 := v1;
            results.msg2 := msg2;
            results.v2 := v2;
            results.diff := v1 - v2;
            return next results;

        end loop;
    end if;

--		N O M I N A L   L E D G E R

-- 22. Check that 'BALANC' account is zero.

    msg1 := '"BALANC" Account';
    msg2 := '';

    select sum(amount)
    into v1
    from nltrans;

    if (v1 is null) then
	v1 := 0;
    end if ;

    v2 := 0.00;

    results.seq := 22;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := v2;
    results.diff := v1 - v2;
    return next results;

-- 23. Check Current Trial Balance

    msg1 := 'Current Trial Balance';
    msg2 := '';

    create temp table audit_currnltb as
    select S1.cod, sum(amount) as amount,pm.period,s1.description
    from nominal s1, nominal s2, nltrans t, period_map pm, nparams ctl
    where s1.lft NOT BETween s2.lft and s2.rgt
      and s2.cod = 'TRADIN'
      and t.period BETWEEN pm.boy_period and pm.period
      and pm.period = ctl.current_period
      and t.cod = s1.cod
      and tmp = 'N'
    group by 1,3,4

    union ALL

    select account_code, sum(amount) as amount, pm.period, 'Accumulated Profit'
    from nominal s1, nominal s2, nltrans t, reserved_ac r, period_map pm, nparams ctl
    where s1.lft between s2.lft and s2.rgt
    and s2.cod = 'TRADIN'
    and t.period >= pm.boy_period
    and t.period < pm.period
    and pm.period = ctl.current_period
    and t.cod = s1.cod
    and tmp = 'N'
    and r.key_name = 'capital'
    group by 1,3,4

    union all

    select S1.cod, sum(amount) as amount, t.period, s1.description
    from nominal s1, nominal s2, nltrans t, nparams ctl
    where s1.lft BETween s2.lft and s2.rgt
      and s2.cod = 'TRADIN'
      and t.period = ctl.current_period
      and t.cod = s1.cod
      and tmp = 'N'
    group by 1,3,4
    order by 3,1;


    select sum(amount)
    into v1
    from audit_currnltb ;

    drop table audit_currnltb;

    v2 := 0.00;

    results.seq := 23;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := v2;
    results.diff := v1 - v2;
    return next results;

-- 24. Check Year to Date Trial Balance

    msg1 := 'Year To Date Trial Balance';
    msg2 := '';

    select sum(amount)
      into v1
      from nominal s1, nominal s2, nltrans t, period_map pm, nparams ctl
     where s1.lft between s2.lft and s2.rgt
       and s2.cod = 'BALANC'
       and t.period between pm.boy_period and pm.period
       and pm.period = ctl.current_period
       and t.cod = s1.cod
       and tmp = 'N';


    v2 := 0.00;

    results.seq := 24;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := v2;
    results.diff := v1 - v2;
    return next results;

-- 25. Check Leaf Node Accounts Vs Transactions




-- 26.  Check The Sum Of Nominal Transactions = Zero

    msg1 := 'Posted Double Entry Integrity';
    msg2 := '';

    select sum(amount)
    into v1
    from nltrans
    where nltrans.period = Pnparams_current
      and nltrans.tmp = 'N';

    results.seq := 26;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := 0.00;
    results.diff := v1 - 0.00;
    return next results;

-- 27.  Unposted Double Entry Integrity

    msg1 := 'Un-p Double Entry Integrity';
    msg2 := '';

    select sum(amount)
    into v1
    from nltrans
    where nltrans.period = Pnparams_current
      and nltrans.tmp = 'Y';

    if v1 is null then
        v1 := 0.00;
    end if;

    results.seq := 27;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := 0.00;
    results.diff := v1 - 0.00;
    return next results;

-- 28.  Check invoice headers against the sum of their detail lines.

    for ihead_row in
    select *
    from ihead
    where period = w_period
    loop

        select sum(goods + vat)
        into a1
        from ihdetail
        where ihdetail.location = ihead_row.location
          and ihdetail.ref      = ihead_row.ref
          and ihdetail.doc_type = ihead_row.doc_type;

        if a1 is null then
            a1 := 0.0;
        end if;

        select sum(goods + vat)
        into c1
        from iodetail
        where iodetail.location = ihead_row.location
          and iodetail.ref      = ihead_row.ref
          and iodetail.doc_type = ihead_row.doc_type;

        if c1 is null then
            c1 := 0.00;
        end if;

        select sum(goods + vat)
        into b1
        from iddetail
        where iddetail.location = ihead_row.location
          and iddetail.ref      = ihead_row.ref
          and iddetail.doc_type = ihead_row.doc_type;

        if b1 is null then
            b1 := 0.00;
        end if;

        w1 := a1 + b1 + c1;

        if w1 <> ihead_row.tot then
           diff = w1 - ihead_row.tot;
           if diff < 0 then
              diff = 0 - diff;
           end if;
           if diff <> .01 then
               msg1 = 'Header: ' || ihead_row.location|| '/'||
	                  ihead_row.cust || '/' || ihead_row.ref;
               msg2 = 'Detail Lines';

               results.seq := 28;
               results.msg1 := msg1;
               results.v1 := ihead_row.tot;
               results.msg2 := msg2;
               results.v2 := w1;
               results.diff := ihead_row.tot - w1;
               return next results;
           end if;
        end if;
    end loop;

--		P L A N T   R E G I S T E R

-- 29.  Check Plant Cost Vs Nominal

    for asset_reg_row in
    select *
    from asset_reg
    loop

        select sum(pcost.qty * pcost.unit_cost),
	       sum(pcost.qty * pcost.unit_depn)
        into v1, tot_depn		-- may as well get depn at this pt
        from pcost			-- will need it for next check
        where pcost.asset_reg = asset_reg_row.cod;

	select cur_bal
	into v2
	from nlbals
	where nlbals.period = Pnparams_current
	  and nlbals.cod = asset_reg_row.nominal_cost;

	if (v2 is null) or (not FOUND) then
	    v2 := 0.00;
	end if;

	select sum(amount)
	into w_tmp
	from nltrans
	where nltrans.cod = asset_reg_row.nominal_cost
	  and nltrans.tmp = 'Y';

	if w_tmp is null then
	    w_tmp := 0.00;
	end if;

	v2 := v2 + w_tmp;

        msg2 := 'Nominal Equipment At Cost';
	msg1 := asset_reg_row.description;

        results.seq := 29;
        results.msg1 := msg1;
        results.v1 := v1;
        results.msg2 := msg2;
        results.v2 := v2;
        results.diff := v1 - v2;
        return next results;

	v1 := tot_depn;

	select cur_bal
	into v2
	from nlbals
	where nlbals.period = Pnparams_current
	  and nlbals.cod = asset_reg_row.nominal_accum_depn;

	if (v2 is null) or (not FOUND) then
	    v2 := 0.00;
	end if;

	select sum(amount)
	into w_tmp
	from nltrans
	where nltrans.cod = asset_reg_row.nominal_accum_depn
	  and nltrans.tmp = 'Y';

	if w_tmp is null then
	    w_tmp := 0.00;
	end if;

	v2 := v2 + w_tmp;

	v2 := 0 - v2;

	msg2 := 'Nominal Accumulated Depn';

        results.seq := 30;
        results.msg1 := msg1;
        results.v1 := v1;
        results.msg2 := msg2;
        results.v2 := v2;
        results.diff := v1 - v2;
        return next results;

    end loop;

    select sum(pcost.qty * pcost.unit_cost) -
               sum(pcost.qty * pcost.unit_depn)
    into v1
    from pcost
    where pcost.asset_reg = 'H';

    v2 := total_register();

    msg1 := 'Sum of Pcost';
    msg2 := 'Plant Register Report';

    results.seq := 31;
    results.msg1 := msg1;
    results.v1 := v1;
    results.msg2 := msg2;
    results.v2 := v2;
    results.diff := v1 - v2;
    return next results;

    select count(*)
    into Pnullcnt
    from nlbatch
    where seq is null
    or source is null;

    if Pnullcnt > 0 then
	if Pnullcnt = 1 then
	    msg1 := Pnullcnt || ' null batch is present.';
	else
	    msg1 := Pnullcnt || ' null batches are present.';
	end if;

        results.seq := 32;
        results.msg1 := msg1;
        results.v1 := null;
        results.msg2 := null;
        results.v2 := null;
        results.diff := null;
        return next results;

    end if;

    for nlbatch_row in
    select *
    from nlbatch
    where nlbatch.stat = 'I'
    loop

        msg1 := ' Incomplete batch :- ' || nlbatch_row.source || ' ' || nlbatch_row.seq;

        results.seq := 33;
        results.msg1 := msg1;
        results.v1 := null;
        results.msg2 := null;
        results.v2 := null;
        results.diff := null;
        return next results;

    end loop;

    for chdetail_row in
       select *
       from chdetail
       where date_from is null or date_started is null
    loop

        msg1 := ' Null date on contract :- ' || chdetail_row.contract;

        results.seq := 34;
        results.msg1 := msg1;
        results.v1 := null;
        results.msg2 := null;
        results.v2 := null;
        results.diff := null;
        return next results;

    end loop;

    --
    -- Verify all Debtors Batches Against the Nominal
    --

    found_checkpoint := false;

    for last_checkpoint in
        select period
        from nltrans, reserved_ac
        where nltrans.cod = reserved_ac.account_code
          and reserved_ac.key_name = 'debtors'
          and nltrans.source = 'CP'
        order by period desc
    loop
        found_checkpoint := true;
        exit;

    end loop;

   select current_date
     into w_today;

    if found_checkpoint then

        for sales_period in
            select distinct period
            from sledger
            where period between last_checkpoint.period and w_today
            order by period
         loop

             for w_ver in
                 select *
                   from verify_dr_nl(sales_period.period,1)
             loop

                 results.seq := 32;
                 results.v1 := w_ver.subledger_total;
                 results.msg2 := sales_period.period || ' ' ||w_ver.source
                                 || '/' || w_ver.batch || ' ' ||w_ver.direction;
                 results.msg1 := w_ver.comment;
                 results.v2 := w_ver.nominal_total;
                 results.diff := v1 - v2;
                 return next results;

              end loop;

         end loop;

         for creditors_period in
            select distinct period
            from pledger
            where period between last_checkpoint.period and w_today
            order by period
         loop

             for w_ver in
                 select *
                   from verify_cr_nl(creditors_period.period,1)
             loop

                 results.seq := 33;
                 results.v1 := w_ver.subledger_total;
                 results.msg2 := creditors_period.period || ' ' || w_ver.source
                               || '/' || w_ver.batch || ' ' ||w_ver.direction;
                 results.msg1 := w_ver.comment;
                 results.v2 := w_ver.nominal_total;
                 results.diff := v1 - v2;
                 return next results;

              end loop;

         end loop;


     end if;







    return;


end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION audit() OWNER TO postgres;


-- pl_open_bal bugfix

-- Function: pl_open_bal(date)

-- DROP FUNCTION pl_open_bal(date);

CREATE OR REPLACE FUNCTION pl_open_bal(pperiod date)
  RETURNS jp_open_bal AS
$BODY$
DECLARE
  Pcreditors      nominal.cod%type;
  Pmovement     decimal(16,2);
  Pmsg          char(60);
  row_found     boolean;
  result        jp_open_bal;
  base_row      record;
  w_rows        integer;
BEGIN

---
--- 1.  Get the opening balance from the checkpoint previous to the period
---     selected

    result.balance := 0.00;

    select account_code
      into Pcreditors
      from reserved_ac
     where reserved_ac.key_name = 'creditor_total';

    get diagnostics w_rows = ROW_COUNT;

    if w_rows = 0 then
         result.ret_string := 'Creditors Control Account not defined on reserved accounts';
         result.ret_stat := 1;
         return result;
    end if;

    row_found := false;

    for base_row in select sum(0 - amount) as amount, period
                      from nltrans,nominal
                     where nltrans.source = 'CP'
                       and nltrans.period <= Pperiod
                       and nltrans.cod = nominal.cod
                       and nominal.parent = Pcreditors
                  group by  period
                  order by  period desc
    loop

        row_found = true;
        exit;

    end loop;

    if not row_found then
       result.ret_stat := 1;
       result.ret_string := 'There is no nominal checkpoint before the requested period';
       return result;
    end if;

    ---
    --- We now have the balance on the debtors nominal and the period
    ---

    Pmovement := 0.00;


    select sum(amount)
    into Pmovement
    from pledger
    where period >= base_row.period
      and period < pperiod
      and supplier is not null;


    if Pmovement is null then
        Pmovement := 0.00;
    end if;

    result.ret_stat := 1;
    result.ret_string = 'Success';
    result.balance := base_row.amount + Pmovement;
    return result;

END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION pl_open_bal(date) OWNER TO postgres;

CREATE OR REPLACE FUNCTION "public"."analyse_plalloc" (p_supplier text) RETURNS SETOF "public"."jp_audit" AS
$body$
DECLARE
 alloc_row     record;
 er_row        record;
 ee_row        record;
 err           sp_status;
 audit_row     record;
 results       jp_audit;
BEGIN

  BEGIN
     create table aud_plalloc(
           ser integer,
           typ integer,
           amount decimal(16,2),
           os decimal(16,2),
           allocated decimal(16,2),
           allocations decimal(16,2)
       );
   EXCEPTION
      WHEN OTHERS THEN
          raise notice 'Table already exists';
   END;
         insert INTO aud_plalloc(ser, typ, amount, os, allocated, allocations)

   select ser, 0 as typ, original,currency_os, (original - currency_os) as allocated, original as allocations
     from pledger
    where supplier = p_supplier;
      update aud_plalloc set allocations = 0.00;

   for alloc_row in
    select allocation            from pallocper
     where supplier = p_supplier
   loop

       for er_row in
	   select er, amount
	   from pallocer
         where pallocer.allocation = alloc_row.allocation
       loop
             update aud_plalloc
                set allocations = allocations - er_row.amount
              where aud_plalloc.ser = er_row.er;

       end loop;
              for ee_row in
        select ee, amount + discount    as alloc_amount                 from pallocee
          where pallocee.allocation = alloc_row.allocation
        loop


           update aud_plalloc
              set allocations = allocations + ee_row.alloc_amount
            where aud_plalloc.ser = ee_row.ee;

       end loop;

   end loop;
     for audit_row in select *
     from aud_plalloc
  where allocated <> allocations
  loop

             results.seq := 13;
             results.msg1 := 'Unbalanced Allocation';
             results.v1 := audit_row.allocated;
             results.msg2 := 'Serial = ' || audit_row.ser;
             results.v2 := audit_row.allocations;
             results.diff := audit_row.allocated - audit_row.allocations;
             return next results;

   end loop;      delete from aud_plalloc;

END;
$body$
LANGUAGE 'plpgsql' VOLATILE RETURNS NULL ON NULL INPUT SECURITY INVOKER;

CREATE OR REPLACE FUNCTION "public"."repair_plalloc" (p_supplier text) RETURNS SETOF "public"."jp_audit" AS
$body$
DECLARE
 alloc_row     record;
 er_row        record;
 ee_row        record;
 err           sp_status;
 audit_row     record;
 results       jp_audit;

BEGIN

  BEGIN
     create table aud_plalloc(
           ser integer,
           typ integer,
           amount decimal(16,2),
           os decimal(16,2),
           allocated decimal(16,2),
           allocations decimal(16,2)
       );
   EXCEPTION
      WHEN OTHERS THEN
          raise notice 'Table already exists';
   END;
         insert INTO aud_plalloc(ser, typ, amount, os, allocated, allocations)

   select ser, 0 as typ, original,currency_os, (original - currency_os) as allocated, original as allocations
     from pledger
    where supplier = p_supplier;
      update aud_plalloc set allocations = 0.00;

   for alloc_row in
    select allocation            from pallocper
     where supplier = p_supplier
   loop

       for er_row in
	   select er, amount
	   from pallocer
         where pallocer.allocation = alloc_row.allocation
       loop
             update aud_plalloc
                set allocations = allocations - er_row.amount
              where aud_plalloc.ser = er_row.er;

       end loop;
              for ee_row in
        select ee, amount + discount    as alloc_amount                 from pallocee
          where pallocee.allocation = alloc_row.allocation
        loop


           update aud_plalloc
              set allocations = allocations + ee_row.alloc_amount
            where aud_plalloc.ser = ee_row.ee;

       end loop;

   end loop;
     for audit_row in select *
     from aud_plalloc
  where allocated <> allocations
  loop

		update pledger
		set currency_os = audit_row.amount - audit_row.allocated,
	    os = (audit_row.amount - audit_row.allocated ) * pledger.conversion_rate
       where ser = audit_row.ser;

  end loop;

  delete from aud_plalloc;

END;
$body$
LANGUAGE 'plpgsql' VOLATILE RETURNS NULL ON NULL INPUT SECURITY INVOKER;

-- Function: fix_pledger_trans(date)

-- DROP FUNCTION fix_pledger_trans(date);

CREATE OR REPLACE FUNCTION fix_pledger_trans(p_period date)
  RETURNS sp_status AS
$BODY$
DECLARE
  ledger_summary            record;
  Pdifference               decimal(16,2);
  p_date                    date;
  Ptype                     pledger.typ%type;
  Pref                      pledger.ref%type;
  result                    sp_status;


BEGIN
     for ledger_summary in select supplier, balance, sum(amount) as amount , sum(os) as os
                from pledger, supplier
                where supplier is not null
                and supplier = supplier.cod
                group by 1, 2
                having balance <> sum(amount)
      loop


          Pdifference := ledger_summary.os - ledger_summary.amount;

          if Pdifference < 0 then
                  Ptype := 13;
                  Pref  := 'Journal Dr';
          else
                  Ptype := 3 ;
                  Pref  := 'Journal Cr';
          end if;

          -- If there is a difference , then we must add a correcting amount transaction
          -- Date will be the 1st of the Period.

          p_date := jp_period(p_period);
          if Pdifference <> 0 then

                        insert into pledger values (
                                ledger_summary.supplier,
                                p_date,
                                default,
                                p_date,
                                Ptype,
                                Pdifference,
                                0.00,
                                Pdifference,
                                0.00,
                                Pref,
                                'FIX',
                                1.00,
                                'EUR',
                                'N',
                                null,
                                null,
                                0,
                                1,
                                null,
                                null,
                                0,
                                null,
                                0,
                                null,
                                0.00,
								null
                          );

          end if;

      end loop;

      result.ret_stat := 0;
      result.ret_string := 'Success';
      return result;

END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION fix_pledger_trans(date) OWNER TO postgres;

update dcssqlversion
set minor = 12,major = 8 , tstamp = now();

-- tables required for locking
create table sessionlock
  (
    id serial not null ,
    operator integer,
    tstamp date,
    primary key (id)
  );


create table lockrows
  (
    key char(255),
    session_id integer,
    primary key (key)
  );

-- Function: recover_bad_debt(integer, text, numeric, text, date, integer, text)

-- DROP FUNCTION recover_bad_debt(integer, text, numeric, text, date, integer, text);

CREATE OR REPLACE FUNCTION recover_bad_debt(p_depot integer, p_cod text, p_amount numeric, p_ref text, p_date date, p_user integer, p_cash_ac text)
  RETURNS sp_status AS
$BODY$
declare	p_val		 sledger.amount%type;
      	p_period	 sledger.period%type;
      	p_bd_recovered	 nominal.cod%type;
      	p_vat_account	 nominal.cod%type;
      	p_debtor 	 nominal.cod%type;
        p_vat_rate       vat.rate%type;
      	p_time		 sledger.tim%type;
      	Pser		 sledger.ser%type;
        p_seq            source.nxt%type;
        p_source         nlbatch.source%type;
      	p_note		 sledger.txt%type;
        pos_vat          cust.balance%type;
        p_balance        cust.balance%type;
        pos_goods        cust.balance%type;
        p_vat            cust.balance%type;
        p_goods          cust.balance%type;
        Plincount       integer;
        w_errnum        integer;
        w_errtxt        char(60);
        p_shadow_ledgers integer;
        w_home		     char(3);
        p_istrading      char(1);
        p_costcentre     char(4);
        p_cnt            integer;
        this_date        date;
	    err		         sp_status;

begin

    select * from get_home_currency()
    into w_home;

    p_source := 'BR';
    p_cnt := 0;

    select count(*)
    into Plincount
    from cust
    where cust.cod   = p_cod
      and cust.depot = p_depot
      and cust.bad_debt = 'Y' ;

    if Plincount is null then
        Plincount = 0;
    end if;

    if Plincount = 0 then
         err.ret_stat := 1; --there is an error
         err.ret_string := 'This Customer is Not a Bad Debt';
         return err ;
    end if;

    if p_amount = 0.00 then
         err.ret_string := 'Payments must be non zero';
         err.ret_stat := 1; --there is an error
         return err;
    end if;

    select account_code
      into p_bd_recovered
      from reserved_ac
     where reserved_ac.key_name = 'bd_recovered';

    if p_bd_recovered is null then
         err.ret_string = 'Bad Debts Recovered Reserved Account Is NULL';
         err.ret_stat = 1; --there is an error
         return err;
    end if;


    select count(*)
    into p_cnt
    from nominal
    where nominal.cod = p_bd_recovered
      and nominal.leafs = 0;

    if p_cnt = 0 then
         err.ret_string = 'Bad Debts Recovered Reserved Account Is not on Nominal as a leaf node';
         err.ret_stat = 1; --there is an error
         return err;
    end if;

    select account_code
      into p_vat_account
      from reserved_ac
     where reserved_ac.key_name = 'vat';

    if p_vat_account is null then
         err.ret_string = 'VAT Reserved Account Is NULL';
         err.ret_stat = 1; --there is an error
         return err;
    end if;

    p_cnt := 0;

    select count(*)
    into p_cnt
    from nominal
    where nominal.cod = p_vat_account
      and nominal.leafs = 0;

    if p_cnt = 0 then
         err.ret_string = "VAT Reserved Account Is not on Nominal as a leaf node";
         err.ret_stat = 1; --there is an error
         return err;
    end if;

    select account_code
      into p_debtor
      from reserved_ac
     where reserved_ac.key_name = 'debtors';

    if p_debtor is null then
         err.ret_string = 'Debtors Reserved Account Is NULL';
         err.ret_stat = 1; --there is an error
         return err;
    end if;

    p_cnt := 0;

    select count(*)
    into p_cnt
    from nominal
    where nominal.cod = p_debtor
      and nominal.leafs = 0;

    if p_cnt = 0 then
         err.ret_string = 'Debtors Reserved Account Is not on Nominal as a leaf node';
         err.ret_stat = 1; --there is an error
         return err;
    end if;


    select dparams.period
    into p_period
    from dparams;

    --create batch header.

    select source.nxt
    into p_seq
    from source
    where source.cod = p_source;

    if not found then
       err.ret_string := 'SOURCE "BR" not setup';
       err.ret_stat := 1;
       return err;
    end if;

    update source
    set nxt = nxt + 1
    where cod = p_source;

    --this_date := current_date;

    insert  into nlbatch values (
            p_source,
            p_seq,
            'S',
            p_period,
            CURRENT_DATE,
            p_depot,
            'I',        -- batch status incomplete
            null        -- presume no link to journals
        );

    p_val := 0 - p_amount;

    --p_time := CURRENT_TIME;

    insert into sledger values (
		nextval('sledger_ser_seq'),
		p_depot,
		p_cod,
		p_date,
	 	p_period,
		18,
		p_amount,
		0.00,
		p_depot,
		NULL,
		p_ref,
		0.00,
   		p_source,
		p_seq,
		'Bad Debt Recov',
		NULL,
		NULL,
		p_user,
		NULL ,
		CURRENT_TIME,
		NULL,
		NULL
		);

     select currval('sledger_ser_seq') into Pser;


     if Pser < 0 then
         err.ret_string := 'Error inserting in sledger';
         err.ret_stat := 1;
         return err;
     end if;

    --touchcust

    select sys_config.set
    into p_shadow_ledgers
    from sys_config
    where sys_config.num = 8;

    if p_shadow_ledgers  = 1 then
        insert into touched values (p_depot, p_cod);
    end if;

    select nparams.bd_recovered, nparams.vat
    into p_bd_recovered, p_vat_account
    from nparams;

    select count(*)
    into Plincount
    from nltrans
    where location = p_depot
      and source = p_source
      and batch  = p_seq
      and cod    = p_debtor;

    if Plincount is null then
       Plincount := 0;
    end if;

    if Plincount = 0 then

        insert into nltrans values (
			nextval('nltrans_trans_no_seq'),
			p_debtor,
			NULL,
			NULL,
			p_date,
			p_source,
			p_seq,
			p_cod,
			p_amount,
			'Bad Debt Recovered',
			NULL,
			'N',
			'Y',
			p_depot,
			null,	--	cleared only for bank
			w_home,
			p_amount
		    );

    else
        update nltrans
        set amount = amount + p_amount,
            currency_amount = currency_amount + p_amount
        where source   = p_source
          and batch    = p_seq
          and cod      = p_debtor;

     end if;

---I am presuming first rate of VAT (21% vat)

      select vat.rate
      into p_vat_rate
      from vat
      where vat.cod = 1;

      p_vat_rate := (p_vat_rate + 100) / 100;

      p_goods := (p_amount / p_vat_rate);
      p_vat   := (p_amount - p_goods);
      p_goods := 0 - p_goods;
      p_vat   := 0 - p_vat;

      select trading into p_istrading
        from nominal where cod = p_bd_recovered;

      if p_istrading = 'Y' then
        select cost_centre into p_costcentre
        from depot where cod = p_depot;
      else
        p_costcentre = null;
      end if;

      select count(*)
      into Plincount
      from nltrans
      where location = p_depot
        and source = p_source
        and batch  = p_seq
        and cod    = p_bd_recovered
        and cc     = p_costcentre;

      if Plincount is null then
          Plincount := 0;
      end if;

      if Plincount = 0 then
	      insert into nltrans values (
				nextval('nltrans_trans_no_seq'),
				p_bd_recovered,
				p_costcentre,
				NULL,
				p_date,
				p_source,
				p_seq,
				'',
				p_goods,
				'Batch Total',
				NULL,
				'N',
				'Y',
				p_depot,
				null,	--	cleared only for bank
				w_home,
				p_goods
			);
      else
	      update nltrans
	         set amount   = amount + p_goods,
	             currency_amount   = currency_amount + p_goods
	       where source = p_source
  	         and batch  = p_seq
  	         and cod    = p_bd_recovered
            and nltrans.cc     = p_costcentre;
      end if;

      select count(*)
      into Plincount
      from nltrans
      where location = p_depot
        and source = p_source
        and batch  = p_seq
        and cod    = p_vat_account;

      if Plincount is null then
          Plincount := 0;
      end if;

      if Plincount = 0 then
          insert into nltrans values (
				nextval('nltrans_trans_no_seq'),
				p_vat_account ,
				NULL,
				NULL,
				p_date,
				p_source,
				p_seq,
				'',
				p_vat,
				'Batch Total',
				NULL,
				'N',
				'Y',
				p_depot,
				null,	--	cleared only for bank
				w_home,
				p_vat
			);
      else
	      update nltrans
	         set amount = amount + p_vat,
	             currency_amount = currency_amount + p_vat
           where source   = p_source
	         and batch    = p_seq
	         and cod      = p_vat_account ;
	  end if;

      --
      -- DC - 'park' the VAT on the sledger type 18 even though it is only a payment.
      --

      update sledger
      set vat = abs(p_vat)
      where ser = Pser;

      update cust
        set bad_debt = 'N'
	where depot = p_depot
	  and cod   = p_cod
	  and bad_debt = 'Y';

        -- update turnover.

        select count(*)
          into Plincount
	      from turnover
         where depot  = p_depot
	       and cod    = p_cod
	       and typ    = 4		--	Cash this month
	       and period = p_period;

	  if Plincount is null then
             Plincount := 0;
      end if;

          if Plincount = 0 then
	     insert into turnover values (
			p_depot,
			p_cod,
			4,
			p_period,
			p_amount
		    );
	  else
	      update turnover
		set amount = amount + p_amount
		where depot = p_depot
		  and cod   = p_cod
		  and typ   = 4
		  and period = p_period;
       end if;

          pos_goods := 0 - p_goods;
          pos_vat   := 0 - p_vat;

          select  count(*)
          into Plincount
          from vatsum
          where cod = 1
            and period = p_period
            and trans  = 18
            and ledger = 'S';

          if Plincount is null then
              Plincount := 0;
          end if;

          if Plincount = 0 then
               insert into vatsum values (
                   1,
                   'S',
                   18,
                   pos_goods,
                   pos_vat,
                   p_period
                );
          else
               update vatsum
                   set goods = goods + pos_goods ,
                       vat   = vat   + pos_vat
                   where cod = 1
                    and period = p_period
                    and trans  = 18
                    and ledger = 'S';
          end if;

       --Complete Batches

          update nlbatch
          set stat = 'C'  -- complete
          where source = p_source
            and seq     = p_seq;

          err.ret_stat := 0;
          err.ret_string := 'Success';
          return err;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION recover_bad_debt(integer, text, numeric, text, date, integer, text) OWNER TO postgres;

-- Function: writeoff_bad_debt(integer, character, integer)

-- DROP FUNCTION writeoff_bad_debt(integer, character, integer);

CREATE OR REPLACE FUNCTION writeoff_bad_debt(p_depot integer, p_cod character, p_user integer)
  RETURNS sp_status AS
$BODY$

declare w_errnum 	integer;
       w_errtxt 	char(60);
       Plincount	smallint;
       ok		smallint;
       p_contract	chdetail.contract%type;
       p_source         source.cod%type;
       p_seq            integer;
       sled_serial      integer;
       p_shadow_ledgers integer;
       p_period	        dparams.period%type;
       p_debtors	nominal.cod%type;
       p_bad_debts	nominal.cod%type;
       p_vat_account    nominal.cod%type;
       p_val		cust.balance%type;
       p_vat		cust.balance%type;
       p_vat_chg	cust.balance%type;
       p_vat_rate	vat.rate%type;
       p_excl	        cust.balance%type;
       p_balance	cust.balance%type;
       p_unallocated	cust.balance%type;
       p_bad_debt       cust.bad_debt%type;
       p_goods          cust.balance%type;
       neg_goods        cust.balance%type;
       neg_vat          cust.balance%type;
       p_cc		depot.cost_centre%type;
       p_time		sledger.tim%type;
       w_home	        char(3);
       err		sp_status;
       chdetail_row	record;

begin

   select * from  get_home_currency()
   into w_home;

--   set debug file to 'wobd.out';
--   trace on;

   p_source := 'BD';

   select count(*)
   into Plincount
   from cust
   where cust.depot = p_depot
     and cust.cod   = p_cod;

   if Plincount is null then
      Plincount := 0;
   end if;

   if Plincount = 0 then
        err.ret_stat := 1; --there is an error
	err.ret_string := 'No such Customer On Database';

        return err;
   end if;

   ok := 1;

   for chdetail_row in
       select chdetail.contract
       --into p_contract
       from chdetail
       where cust = p_cod
	and depot = p_depot

   loop
       /*
       for chcount_row in
	    select count(*) as cnt
	    --into Plincount
	    from chdetail
	    where contract = chdetail_row.contract
              and chdetail.depot = p_depot
       loop
	    if chcount_row.cnt != 0 then
	        ok := 0;
	        exit;
	    end if;

       end loop;
       */


       select count(*) as cnt
       into Plincount
       from chdetail
       where contract = chdetail_row.contract
       and chdetail.depot = p_depot;

       if Plincount != 0 then
	   ok :=0;
           exit;
       end if;
       /*
       for cocount_row in
	    select count(*) as cnt
	    --into Plincount
	    from codetail
	    where contract = chdetail_row.contract
              and codetail.depot = p_depot
       loop
	    if cocount_row.cnt != 0 then
	        ok := 0;
	        exit;
	    end if;

       end loop;
	*/

       select count(*) as cnt
       into Plincount
       from codetail
       where contract = chdetail_row.contract
       and codetail.depot = p_depot;


       if Plincount != 0 then
          ok := 0;
          exit;
       end if;

       /*
       for cdcount_row in
	    select count(*) as cnt
	    --into Plincount
	    from cdisposal
	    where contract = chdetail_row.contract
              and disposal.depot = p_depot
       loop
	    if cdcount_row.cnt != 0 then
	        ok = 0;
	        exit;
	    end if;

       end loop;
       */

       select count(*) as cnt
       into Plincount
       from cdisposal
       where contract = chdetail_row.contract
       and disposal.depot = p_depot;

       if Plincount != 0 then
	   ok := 0;
           exit;
       end if;

    end loop;

    if ok = 0 then
        err.ret_stat := 1; --there is an error
	err.ret_string := 'There are contracts outstanding for this customer' ;
        return err;
    end if;

    select cust.bad_debt, cust.balance, cust.unallocated
    into p_bad_debt,p_balance,p_unallocated
    from cust
    where cust.cod = p_cod
      and cust.depot = p_depot;

    select sum(amount)
    into p_balance
    from sledger
    where cod = p_cod
    and   depot = p_depot;


    select sum(os)
    into p_unallocated
    from sledger
    where cod = p_cod
    and depot = p_depot
    and typ > 10;

    if p_balance = 0 then
       err.ret_stat :=  'Balance Must be Non Zero' ;
       err.ret_string := 1;
       return err;
    end if;

    if p_unallocated <> 0 then
       err.ret_stat :=  'Unallocated Cash Must Be Allocated First';
       err.ret_string := 1;
       return err;
    end if;

    if p_bad_debt = 'Y' then
       err.ret_stat := 'This is already a bad debt account';
       err.ret_string := 1;
       return err;
    end if;

    --all check out ok therefore write the account off.

    select dparams.period
    into p_period
    from dparams;

    --create batch header.

    select source.nxt
    into p_seq
    from source
    where source.cod = p_source;

    if not found then
       err.ret_stat := 'SOURCE "DP" not setup';
       err.ret_string := 1;
       return err;
    end if;

    update source
    set nxt = nxt + 1
    where cod = p_source;

    insert  into nlbatch values (
            p_source,
            p_seq,
            'S',
            p_period,
            current_date,
            p_depot,
            'I',        -- batch status incomplete
            null        -- presume no link to journals
        );

    --touchcust

    select sys_config.set
    into p_shadow_ledgers
    from sys_config
    where sys_config.num = 8;

    if p_shadow_ledgers  = 1 then
        insert into touched values (p_depot, p_cod);
    end if;

    update cust
    set bad_debt = 'Y',
    statement = 'N'
    where depot = p_depot
    and cod   = p_cod;

    p_val := 0 - p_balance;
    p_time := now();


    insert into sledger values (
	nextval('sledger_ser_seq'),
	p_depot,
	p_cod,
	current_date,
	p_period,
	16,
	p_val,
	0.00,
	p_depot,
	NULL,
	NULL,
	0.00,
   	p_source,
	p_seq,
	'Bad Debt W/O',
	NULL,
	NULL,
	p_user,
	NULL ,
	now(),
	NULL,
	NULL
        );

        select currval('sledger_ser_seq') into sled_serial;
	--select last_value
	--into sled_serial
	--from sledger_ser_seq;

	select debtors, bad_debts , vat
	into p_debtors, p_bad_debts, p_vat_account
	from nparams;

	if not found then
           err.ret_stat := 'NPARAMS not setup';
           err.ret_string := 1;
           return err;
        end if;

	select 	cost_centre
	into	p_cc
	from	depot
	where	depot.cod = p_depot;

	if not found then
	    err.ret_stat := 'Cannot get cost centre details '
	      , ' for depot ', p_depot;
            err.ret_stat := 1;
            return err;
	end if;

---I am presuming whatever vat.cod = 1 is

      select vat.rate
      into p_vat_rate
      from vat
      where vat.cod = 1;

      p_vat_chg  := p_vat_rate / 100;
      p_vat_chg  := p_vat_chg + 1.00;

      p_excl := p_balance / p_vat_chg;
      p_vat  := p_balance - p_excl;

      insert into nltrans values (
			nextval('nltrans_trans_no_seq'),
			p_vat_account,
			p_cc,
			NULL,
			current_date,
			p_source,
			p_seq,
			p_cod,
			p_vat,
			'Bad Debt W/O',
			NULL,
			'N',
			'Y',
			p_depot,
			NULL,	--cleared only for bank
			w_home,
			p_vat
		        );

        update sledger
        set vat = p_vat * -1,
            batch = p_seq
        where ser = sled_serial;

        p_goods := p_balance - p_vat;

	insert into nltrans values (
		nextval('nltrans_trans_no_seq'),
		p_bad_debts,
		p_cc,
		NULL,
		current_date,
		p_source,
		p_seq,
		p_cod,
		p_goods,
		'Bad Debt W/O',
		NULL,
		'N',
		'Y',
		p_depot,
		NULL,	--cleared only for bank
		w_home,
		p_goods
		);


	p_val := 0 - p_balance;

	select count(*)
        into Plincount
        from nltrans
	where source = p_source
  	and batch  = p_seq
  	and cod    = p_debtors
  	and location = p_depot;

	if Plincount = 0 then
		insert into nltrans values (
			nextval('nltrans_trans_no_seq'),
			p_debtors,
			NULL,
			NULL,
			current_date,
			p_source,
			p_seq,
			'',
			p_val,
			'Batch Total',
			NULL,
			'N',
			'Y',
			p_depot,
			NULL,	-- cleared only for bank
			w_home,
			p_val
		);

	else
		update nltrans
			set amount = amount + p_val,
			    currency_amount = currency_amount + p_val
			where source = p_source
	  		and batch    = p_seq
	  		and cod      = p_debtors;

	end if;

        neg_goods := (0 - p_goods);
        neg_vat   := (0 - p_vat);

        select  count(*)
        into Plincount
        from vatsum
        where cod = 1 --I am presuming vat code 1
          and period = p_period
          and trans  = 16
          and ledger = 'S';

        if Plincount is null then
           Plincount := 0;
        end if;

	if Plincount = 0 then
            insert into vatsum values (
                1,
                'S',
                16,
                neg_goods,
                neg_vat,
                p_period
            );
        else
            update vatsum
                set goods = goods + neg_goods,
                    vat   = vat   + neg_vat
                 where cod = 1
                  and period = p_period
                  and trans  = 16
                  and ledger = 'S';
        end if;

       --Complete Batches

        update nlbatch
        set stat = 'C'  -- complete
        where source = p_source
          and seq     = p_seq;

        err.ret_stat := 0;
        err.ret_string := 'Success';
        return err;
end ;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION writeoff_bad_debt(integer, character, integer) OWNER TO postgres;


-- View: v_vatsum_raw

-- DROP VIEW v_vatsum_raw;

CREATE OR REPLACE VIEW v_vatsum_raw AS
(((( SELECT pd.vcode AS cod, 'P' AS ledger, pl.typ AS trans, pd.goods, pd.vat, pl.period
   FROM pdetails pd, pledger pl
  WHERE pd.trans_ser = pl.ser
UNION ALL
 SELECT ixd.vcode AS cod, 'S' AS ledger,
        CASE ih.doc_type
            WHEN 'CR'::bpchar THEN 12
            ELSE 2
        END::smallint AS trans, ixd.goods, ixd.vat, ih.period
   FROM ihead ih, ihdetail ixd
  WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust)
UNION ALL
 SELECT ixd.vcode AS cod, 'S' AS ledger,
        CASE ih.doc_type
            WHEN 'CR'::bpchar THEN 12
            ELSE 2
        END::smallint AS trans, ixd.goods, ixd.vat, ih.period
   FROM ihead ih, iodetail ixd
  WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust)
UNION ALL
 SELECT ixd.vcode AS cod, 'S' AS ledger,
        CASE ih.doc_type
            WHEN 'CR'::bpchar THEN 12
            ELSE 2
        END::smallint AS trans, ixd.goods, ixd.vat, ih.period
   FROM ihead ih, iddetail ixd
  WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust)
UNION ALL
 SELECT 1::smallint AS cod, 'S' AS ledger, sledger.typ AS trans, (sledger.amount - sledger.vat) * (-1)::numeric AS goods, sledger.vat * (-1)::numeric AS vat, sledger.period
   FROM sledger
  WHERE sledger.typ = 16 AND sledger.cod IS NOT NULL)
UNION ALL
 SELECT 1::smallint AS cod, 'S' AS ledger, sledger.typ AS trans, (sledger.amount - sledger.vat) * (-1)::numeric AS goods, sledger.vat * (-1), sledger.period
   FROM sledger
  WHERE sledger.typ = 18 AND sledger.cod IS NOT NULL;

ALTER TABLE v_vatsum_raw OWNER TO postgres;


-- alter to phistory
--alter table pcost  add primary key ( ser );
alter table phistory add column pcost integer;
alter table phistory add foreign key
       ( pcost ) references pcost ;

-- alter to pcost

alter table pcost add column original_qty integer ;
alter table pcost add column qty_invoiced integer ;

-- alter to asset_reg

alter table asset_reg add column equipment_suspense char(6);
alter table asset_reg add foreign key ( equipment_suspense ) references nominal;

-- new table used to keep track of pcost parent rows---
create table pcostxref (
parent          integer,
child           integer
);

-- Function: asatdate(date)

-- DROP FUNCTION asatdate(date);

CREATE OR REPLACE FUNCTION asatdate(asat date)
  RETURNS sp_status AS
$BODY$
declare     unmatched_row       unmatched%rowtype;
            pcost_row           record;
            Psumunmatched      integer;
            Psumpcost           integer;
			firstline			integer;
             cur_asset_reg char(1);
            cur_pdesc   char(4);
            cur_reg char(6);
            cur_qty integer;
            cur_dat date;
            cur_qty_unmatched integer;
            cur_qty_matched integer;
            cur_qty_sold integer;
            cur_sales_period date;
            cur_nominal_period date;
            cur_unit_cost decimal(16,2);
            cur_unit_depn decimal(16,2);
            cur_supp char(6);
            cur_invoice_ref char(10);
            cur_location integer;
            cur_pcost_ser integer;
            cur_qty_invoiced integer;
            err			sp_status;


begin


drop table if exists temp_unmatched;
drop table if exists temp_pcost;

create temp table temp_unmatched
  (
      ser serial not null ,
      asset_reg char(1),
      pdesc char(4),
      reg char(6),
      qty integer,
      dat date,
      cost_per_unit decimal(9,2),
      supplier char(6),
      qty_left integer,
      qty_sold integer,
      location smallint
        );

create temp table temp_pcost
     (
      ser integer,
      asset_reg char(1),
      pdesc char(4),
      reg char(6),
      unit_cost decimal(16,2),
      unit_depn decimal(16,2),
      qty integer,
      dat date,
      supplier char(6),
      invoice_ref char(10),
      source_type char(1),
      original_qty integer,
      qty_invoiced integer
       );



	cur_qty_matched :=0;
	firstline := 1;

	for pcost_row in
	    select h.pcost as pcost, h.ser, h.asset_reg, h.pdesc, h.reg,
                   h.typ, h.sales_period,
                   h.dat, h.unit_cost, h.unit_depn, h.qty,
                   h.supp, h.invoice_ref, h.location, pd.typ as pdtyp

        from phistory h, pdesc pd
	    where h.sales_period <= asat
	    and h.pdesc = pd.cod
	    and h.pcost is not null
        order by 1,2
	loop

	    if firstline = 1 then
	       cur_pcost_ser     := pcost_row.pcost;
           cur_asset_reg     := pcost_row.asset_reg;
           cur_pdesc         := pcost_row.pdesc;
           cur_reg           := pcost_row.reg;
           cur_qty           := 0;
           cur_qty_unmatched := 0;
           cur_qty_matched   := 0;
           cur_qty_sold      := 0;
           cur_unit_cost     := 0;
           cur_unit_depn     := 0;
           cur_invoice_ref   := '';
           cur_supp          := '';
           cur_location      := 1;
           cur_qty_invoiced  := 0;
           firstline         := 0;
        end if;

       if cur_pcost_ser <> pcost_row.pcost then

           if cur_qty_matched > 0 then

	           execute 'insert into temp_pcost values (' || coalesce(quote_literal(cur_pcost_ser),'NULL') || ','
                                            || coalesce(quote_literal(cur_asset_reg),'NULL') || ','
                                            || coalesce(quote_literal(cur_pdesc),'NULL')     ||','
                                            || coalesce(quote_literal(cur_reg),'NULL')        ||','
                                            || coalesce(quote_literal(cur_unit_cost),'NULL') ||','
                                            || coalesce(quote_literal(cur_unit_depn),'NULL') ||','
                                            || coalesce(quote_literal(cur_qty_matched),'NULL')       ||','
                                            || coalesce(quote_literal(cur_dat),'NULL')       ||','
                                            || coalesce(quote_literal(cur_supp),'NULL')    ||','
                                            || coalesce(quote_literal(cur_invoice_ref),'NULL') ||','
                                            || coalesce(quote_literal(''),'NULL') ||','
											|| coalesce(quote_literal(cur_qty_matched),'NULL') ||','
											|| coalesce(quote_literal(cur_qty_invoiced),'NULL') ||
                                            ');';
           end if;

	       cur_pcost_ser     := pcost_row.pcost;
           cur_asset_reg     := pcost_row.asset_reg;
           cur_pdesc         := pcost_row.pdesc;
           cur_reg           := pcost_row.reg;
           cur_qty           := 0;
           cur_qty_unmatched := 0;
           cur_qty_matched   := 0;
           cur_qty_sold      := 0;
           cur_unit_cost     := 0;
           cur_unit_depn     := 0;
           cur_invoice_ref   := '';
           cur_supp          := '';
           cur_location      := 1;
           cur_qty_invoiced  := 0;


        end if;

       if pcost_row.typ = 1 then
             cur_dat           := pcost_row.dat;
             cur_invoice_ref   := pcost_row.invoice_ref;
             cur_supp          := pcost_row.supp;
             cur_location      := pcost_row.location;
             cur_unit_cost     := pcost_row.unit_cost;
             cur_unit_depn     := pcost_row.unit_depn;
             cur_qty_matched   := cur_qty_matched   + pcost_row.qty;
        end if;

        if pcost_row.typ = 2 then
            cur_invoice_ref   := pcost_row.invoice_ref;
            cur_supp          := pcost_row.supp;
            cur_unit_cost     := pcost_row.unit_cost;
            cur_qty_invoiced  := cur_qty_invoiced  + pcost_row.qty;
        end if;

        if pcost_row.typ = 3 then
            if pcost_row.pdtyp = 'M' then
                cur_qty_matched   := cur_qty_matched   - pcost_row.qty;
            else
                cur_qty_matched := 0;
            end if;
        end if;

        if pcost_row.typ = 4 then
            cur_unit_depn     := cur_unit_depn     + pcost_row.unit_depn;
        end if;

        if pcost_row.typ = 5 then
            if pcost_row.qty > 0 then
                cur_unit_cost := pcost_row.unit_cost;
            end if;
        end if;

        if pcost_row.typ = 6 then
            cur_qty           := cur_qty           - hst_qty;
        end if;


        if pcost_row.typ = 7 then
            cur_dat           := pcost_row.dat;
            cur_invoice_ref   := pcost_row.invoice_ref;
            cur_supp          := pcost_row.supp;
            cur_location      := pcost_row.location;
            cur_unit_cost     := pcost_row.unit_cost;
            cur_unit_depn     := pcost_row.unit_depn;
            cur_qty_matched   := cur_qty_matched   + pcost_row.qty;
        end if;

        if pcost_row.typ = 8 then
            if pcost_row.pdtyp = 'M' then
                cur_qty_matched   := cur_qty_matched   - pcost_row.qty;
            else
                cur_qty_matched   = 0;
            end if;
        end if;

        if pcost_row.typ = 9 then
            cur_unit_depn     := cur_unit_depn     + pcost_row.unit_depn;
        end if;

	if pcost_row.typ = 10 then
            cur_qty_invoiced  := cur_qty_invoiced  - pcost_row.qty;
        end if;





	end loop;


	if cur_qty_matched <> 0 then
               execute 'insert into temp_pcost values (' || coalesce(quote_literal(cur_pcost_ser),'NULL') || ','
                                            || coalesce(quote_literal(cur_asset_reg),'NULL') || ','
                                            || coalesce(quote_literal(cur_pdesc),'NULL')     ||','
                                            || coalesce(quote_literal(cur_reg),'NULL')        ||','
                                            || coalesce(quote_literal(cur_unit_cost),'NULL') ||','
                                            || coalesce(quote_literal(cur_unit_depn),'NULL') ||','
                                            || coalesce(quote_literal(cur_qty_matched),'NULL')       ||','
                                            || coalesce(quote_literal(cur_dat),'NULL')       ||','
                                            || coalesce(quote_literal(cur_supp),'NULL')    ||','
                                            || coalesce(quote_literal(cur_invoice_ref),'NULL') ||','
                                            || coalesce(quote_literal(''),'NULL') ||','
											|| coalesce(quote_literal(cur_qty_matched),'NULL') ||','
											|| coalesce(quote_literal(cur_qty_invoiced),'NULL') ||
                                            ');';
    end if;

	execute 'create unique index t_ix312_1 on temp_pcost (ser)';
    execute 'create index t_multidx on temp_pcost (pdesc);';
    execute 'create index pcix2 on temp_pcost (asset_reg,pdesc,reg)';





    err.ret_stat := 0;
    err.ret_string := 'SUCCESS';

    return err;


end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION asatdate(date) OWNER TO postgres;


-- Fix the issue where getpluprices is returning 0 for discount rate instead of null , in certain
-- cases


-- Function: getpluprices(aproducttype integer, apricelist integer, adiscstruct integer)

-- DROP FUNCTION getpluprices(aproducttype integer, apricelist integer, adiscstruct integer);

CREATE OR REPLACE FUNCTION getpluprices(aproducttype integer, apricelist integer, adiscstruct integer)
 RETURNS jp_pluprices AS
$BODY$
/*
--Kevin : 6th March 2003

This procedure returns basic product_type details, plus the Master,
Promotional and Customers prices where and if appropriate.

MASTER -->      Standard price of a product type, with Discount
                if Discount Structure specified.
PROMOTIONAL --> If the item is set on a promotional price.
                Get the Promotional Price, NO DISCOUNTs are applicable
                when dealing with Promotional prices.
CUSTOMER'S -->  If Price Specified, check for pricelist value, if none
                exists use MASTER price.
                If Discount Structure specified apply it to value.
*/

-- Internal Variables

declare pPLU                             char(7);
       pDescription                     char(90);
       pProdCode                        char(7);
       pProdDescription                 char(90);
       pCostPrice                       decimal(16,2);
       pVatCode                         integer;
       pVatRate                         decimal(4,2);
       pMasterSP                        decimal(16,4);
       pCustomerSP                      decimal(16,4);
       pPromoSP                         decimal(16,4);
       pSellPrice                       decimal(16,4);
       pDiscountRate                    decimal(4,2);
       pDiscount                        decimal(16,2);
       pDiscountable                    smallint;
       pLookForDisc                     smallint;
       pCheckPLDisc                     smallint;

       pProduct                         integer;   -- Product Nsuk
       pStockUnit                       char(10);  -- Product Stock Unit
       pRowCnt                          smallint;  -- No. of rows returned
       pPLNsuk                          integer;   -- Holds PriceList Nsuk
       pPromoNsuk                       integer;   -- Holds Promotion Nsuk
       pDSNsuk                          integer;   -- Holds DiscStruct Nsuk
       pDept                            integer;   -- Department
       pDeptGroup                       integer;   -- Department Group
       pPLparent                        integer;   -- Parent price list
       pSellPriceType                   smallint;  -- Sell Price Type
       ret_price             jp_pluprices;

begin


  pMasterSP := 0.00;
  pCustomerSP := 0.00;
  pPromoSP := 0.00;
  pSellPrice := 0.00;
  pDiscountRate := 0.00;
  pDiscount := 0.00;
  pSellPriceType := 0;
  pPromoNsuk := 0;
  pStockUnit := '';

  pLookForDisc := 1;
  pCheckPLDisc := 0;

/* Intialise the jp_pluprices type to what it will be if we have to return an error
*/

  ret_price.pt := 0;
  ret_price.plu := '';
  ret_price.plu_description := '';
  ret_price.product_code := '';
  ret_price.product_description := '';
  ret_price.cost_price := 0;
  ret_price.vat_code := 0;
  ret_price.vat_rate := 0;
  ret_price.master_price := 0;
  ret_price.promotional_price := 0;
  ret_price.customer_price := 0;
  ret_price.sell_price := 0;
  ret_price.discount_rate := 0;
  ret_price.discount_value := 0;
  ret_price.sell_pricetype := 0;
  ret_price.stock_unit := '';

-- Step One : Get product_type details

       SELECT  plu, product, descr, curr_cost_price, curr_sell_price
       INTO    pPLU, pProduct, pDescription, pCostPrice, pMasterSP
       FROM    product_type
       WHERE   nsuk = aProductType;

   get diagnostics pRowCnt = ROW_COUNT;

       if pRowCnt > 1 then
               ret_price.err_code = 1;
               ret_price.err_text = 'More than one rows returned for PLU';
               return ret_price;
       end if;

       if pRowCnt = 0 then
               ret_price.err_code = 1;
               ret_price.err_text = 'No rows returned for PLU';
               return ret_price;
       end if;

-- Step 2 : Get Vat Rate and Code.
    -- Get VatCode from Product
    -- Get VatRate from Vat

    SELECT p.vcode, v.rate, p.cod, p.description, p.stock_unit
    INTO   pVatCode, pVatRate, pProdCode, pProdDescription, pStockUnit
    FROM   product p, vat v
    WHERE  p.nsuk = pProduct
      AND  p.vcode = v.cod;

    if pStockUnit is null then
      pStockUnit := '';
    end if;


-- Step 3 : Get Dept and Dept_Group Details

   SELECT dg.dept, dg.nsuk
   INTO pDept, pDeptGroup
   FROM dept_group dg , product p
   WHERE p.nsuk = pProduct
     AND p.dept_group = dg.nsuk;


-- Step 4 : Check if pricelist is Discountable or not

   if aPriceList <> 0 then
     SELECT parent
     INTO pPLparent
     FROM pricelist
     WHERE nsuk = aPricelist;

     if pPLparent is null then
       pPLparent := 0;
     end if;

   end if;

   pDiscountable := 1;


-- Step 5 : Check see if a Promotional Price exists for this item.
    -- Get NSUK for PROMOTION price list (if it exists).

    SELECT nsuk
    INTO pPromoNsuk
    FROM pricelist
    WHERE cod = 'PROMOTION';

    -- If we Found PROMOTION pricelist

    get diagnostics pRowCnt = ROW_COUNT;
    if pRowCnt = 1 then

       -- Check for PLU on Promotion Price List

       SELECT sell_price
       INTO   pPromoSP
       FROM pricelist_det
       WHERE pricelist = pPromoNsuk
         AND product_type = aProductType;

       if not FOUND then

           SELECT sell_price
           INTO   pPromoSP
           FROM pricelist_det
           WHERE pricelist = pPromoNsuk
             AND product = pProduct;

           if not FOUND then
              pPromoSP = 0;
           else
              pLookForDisc = 0;    -- Don't Look for Discount
           end if;
       else
           pLookForDisc = 0;        -- Don't Look for Discount
       end if;

    end if;

-- Step 6 : Check see if a Customer Price exists for this item.

    -- Step 6.1 : If Customer gave a Price List, Check list for Price

    if aPriceList > 0 then

         SELECT sell_price
         INTO   pCustomerSP
         FROM pricelist_det
         WHERE pricelist = aPriceList
           AND product_type = aProductType;

         if not FOUND then

             SELECT sell_price
             INTO   pCustomerSP
             FROM pricelist_det
             WHERE pricelist = aPriceList
               AND product = pProduct;

             if not FOUND then

                 if pPLparent <> 0 then
                     SELECT sell_price
                     INTO   pCustomerSP
                     FROM pricelist_det
                     WHERE pricelist = pPLparent
                       AND product_type = aProductType;

                     if not FOUND then

                         SELECT sell_price
                         INTO   pCustomerSP
                         FROM pricelist_det
                         WHERE pricelist = pPLparent
                           AND product = pProduct;

                         if not FOUND then
                            pCustomerSP = 0;
                         else
                            pCheckPLDisc = 1;        --  Look for Discount
                         end if;
                     else
                         pCheckPLDisc = 1;        --  Look for Discount
                     end if;
                 else
                    -- there is no parent price list
                    pCustomerSP = 0;
                 end if;
             else
                 pCheckPLDisc = 1;
             end if;
         else
             pCheckPLDisc = 1;        --  Look for Discount
         end if;

         pDiscountable := null;

         if pCheckPLDisc = 1 then
            SELECT discountable
            INTO pDiscountable
            FROM pricelist
            WHERE nsuk = aPricelist;

            if pDiscountable is null then
              pDiscountable := 0;
            end if;

            if pDiscountable = 0 then
              pLookForDisc := 0;
            end if;
         end if;

    end if;

-- Step 7: Get Discount Structure Details, IF ANY

  if aDiscStruct <> 0 then

    if pLookForDisc > 0 then

       -- First Check for Discount price for DEPT and DEPT GROUP
       SELECT distinct(discount)
       INTO pDiscountRate
       FROM disc_detail
       WHERE disc_struct = aDiscStruct
         -- AND department = pDept
         AND dept_group = pDeptGroup;

      get diagnostics pRowCnt = ROW_COUNT;
      -- If No results for Dept and Dept Group
      if pRowCnt <> 1 then

          -- Then Check for Discount for just Dept

          SELECT distinct(discount)
          INTO pDiscountRate
          FROM disc_detail
          WHERE disc_struct = aDiscStruct
            AND department = pDept
            AND (dept_group is null or dept_group = -1);

          get diagnostics pRowCnt = ROW_COUNT;
          -- If No Results then Discount is Zero
          if pRowCnt <> 1 then
             pDiscountRate := null;
          end if;

      end if;

    else
       pDiscountRate := null;
    end if; -- if pDiscountable > 0

  end if; -- if aDiscStruct <> ''


-- Step 8: Work out SELL_PRICE to use.

    -- If we have a promotional Price USE THAT
    if pPromoSP > 0 then
       pSellPrice := pPromoSP;
       pSellPriceType := 1;
    else
       -- NOT promo price so see if Customer or Standard price to be used

       if pCustomerSP > 0 then

          -- if Theres a Discount, apply it
          if pDiscountRate is not null then
             pDiscount := ( pCustomerSP / 100 ) * pDiscountRate;
          else
             pDiscount := null;
          end if;

          pSellPrice := pCustomerSP;
          pSellPriceType := 2;
       else

          -- if Theres a Discount, apply it
          if pDiscountRate is not null then
             pDiscount := ( pMasterSP / 100 ) * pDiscountRate;
          else
             pDiscount := null;
          end if;

          pSellPrice := pMasterSP;
          pSellPriceType := 3;
       end if;

    end if;

-- Step 9 : Return Findings

  ret_price.err_code := 0;
  ret_price.err_text := 'Success';
  ret_price.pt := aProductType;
  ret_price.plu := pPLu;
  ret_price.plu_description := pDescription;
  ret_price.product_code := pProdCode;
  ret_price.product_description := pProdDescription;
  ret_price.cost_price := pCostPrice;
  ret_price.vat_code := pVatCode;
  ret_price.vat_rate := pVatRate;
  ret_price.master_price := pMasterSP;
  ret_price.promotional_price := pPromoSP;
  ret_price.customer_price := pCustomerSP;
  ret_price.sell_price := pSellPrice;
  ret_price.discount_rate := pDiscountRate;
  ret_price.discount_value := pDiscount;
  ret_price.sell_pricetype := pSellPriceType;
  ret_price.stock_unit := pStockUnit;

  return ret_price;

end;
$BODY$
 LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION getpluprices(aproducttype integer, apricelist integer, adiscstruct integer) OWNER TO postgres;


-- View: "v_cust_p_danal"


DROP VIEW v_cust_turnover CASCADE;
DROP VIEW v_cust_total CASCADE;
DROP VIEW v_cust_p_danal;

CREATE OR REPLACE VIEW v_cust_p_danal AS
SELECT ih."location", ih.ac_location, ih.cust, ixd.pdesc AS plantorprod, ih.period, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
           ELSE ixd.goods
       END) AS amount, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.qty * (-1)
           ELSE ixd.qty
       END) AS qty
  FROM ihead ih, iddetail ixd
 WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust
 GROUP BY ih."location", ih.ac_location, ih.cust, ixd.pdesc, ih.period;

ALTER TABLE v_cust_p_danal OWNER TO postgres;



-- View: "v_cust_p_hanal"

DROP VIEW v_cust_p_hanal;

CREATE OR REPLACE VIEW v_cust_p_hanal AS
SELECT ih."location", ih.ac_location, ih.cust, ixd.plant_desc AS plantorprod, ih.period, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
           ELSE ixd.goods
       END) AS amount, 0 AS qty
  FROM ihead ih, ihdetail ixd
 WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust
 GROUP BY ih."location", ih.ac_location, ih.cust, ixd.plant_desc, ih.period;

ALTER TABLE v_cust_p_hanal OWNER TO postgres;

-- View: "v_cust_p_hanal_no_x"

-- DROP VIEW v_cust_p_hanal_no_x;

CREATE OR REPLACE VIEW v_cust_p_hanal_no_x AS
SELECT ih."location", ih.ac_location, ih.cust, ixd.plant_desc AS plantorprod, ih.period, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
           ELSE ixd.goods
       END) AS amount, 0 AS qty
  FROM ihead ih, ihdetail ixd
 WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust
 AND (ixd.plant_ref <> '9'::bpchar or ixd.plant_ref is null )
 GROUP BY ih."location", ih.ac_location, ih.cust, ixd.plant_desc, ih.period;

ALTER TABLE v_cust_p_hanal_no_x OWNER TO postgres;

-- View: "v_cust_p_sanal"

DROP VIEW v_cust_p_sanal;

CREATE OR REPLACE VIEW v_cust_p_sanal AS
SELECT ih."location", ih.ac_location, ih.cust, ixd.product AS plantorprod, ih.period, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
           ELSE ixd.goods
       END) AS amount, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.qty * (-1)::numeric
           ELSE ixd.qty
       END) AS qty
  FROM ihead ih, iodetail ixd
 WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust
 GROUP BY ih."location", ih.ac_location, ih.cust, ixd.product, ih.period;

ALTER TABLE v_cust_p_sanal OWNER TO postgres;

-- View: "v_cust_p_xanal"

-- DROP VIEW v_cust_p_xanal;

CREATE OR REPLACE VIEW v_cust_p_xanal AS
SELECT ih."location", ih.ac_location, ih.cust, ixd.plant_desc AS plantorprod, ih.period, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
           ELSE ixd.goods
       END) AS amount, 0 AS qty
  FROM ihead ih, ihdetail ixd
 WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust AND ixd.plant_ref = '9'::bpchar
 GROUP BY ih."location", ih.ac_location, ih.cust, ixd.plant_desc, ih.period;

ALTER TABLE v_cust_p_xanal OWNER TO postgres;


-- recreate parent views v_cust_total and v_cust_turnover

CREATE OR REPLACE VIEW v_cust_total AS
( SELECT v_cust_p_hanal.ac_location, v_cust_p_hanal.cust, v_cust_p_hanal.period, sum(v_cust_p_hanal.amount) AS amount
   FROM v_cust_p_hanal
  GROUP BY v_cust_p_hanal.ac_location, v_cust_p_hanal.cust, v_cust_p_hanal.period
UNION ALL
 SELECT v_cust_p_sanal.ac_location, v_cust_p_sanal.cust, v_cust_p_sanal.period, sum(v_cust_p_sanal.amount) AS amount
   FROM v_cust_p_sanal
  GROUP BY v_cust_p_sanal.ac_location, v_cust_p_sanal.cust, v_cust_p_sanal.period)
UNION ALL
 SELECT v_cust_p_danal.ac_location, v_cust_p_danal.cust, v_cust_p_danal.period, sum(v_cust_p_danal.amount) AS amount
   FROM v_cust_p_danal
  GROUP BY v_cust_p_danal.ac_location, v_cust_p_danal.cust, v_cust_p_danal.period;

ALTER TABLE v_cust_total OWNER TO postgres;

CREATE OR REPLACE VIEW v_cust_turnover AS
 SELECT v_cust_total.ac_location, v_cust_total.cust, v_cust_total.period, sum(v_cust_total.amount) AS amount
   FROM v_cust_total
  GROUP BY v_cust_total.ac_location, v_cust_total.cust, v_cust_total.period;

ALTER TABLE v_cust_turnover OWNER TO postgres;


update dcssqlversion
set major = 8 , minor = 13 , tstamp = now();

update asset_reg
set equipment_suspense = 'EQSUSP';